*-- Author :    Marialuigia Ambriola   12/04/2006
      SUBROUTINE GPTAV
************************************************************************
*                                                                      *
* To define special tracking parameters for:                           *
* Titanium (0.90) - aluminium (0.06) - Vanadium (0.04) mixture         *
* Top Plate                                                            *
* Called by: GPDAT                                                     *
* Author: Marialuigia Ambriola, 26/10/2006 12.18                       *
*                                                                      *
************************************************************************
#include "gptav.inc"
*
      CUTGAMTAV = 0.0001
      CUTELETAV = 0.0001
      CUTNEUTAV = 0.0001
      CUTHADTAV = 0.0001
c ml:
      BCUTETAV=0.001
      DCUTETAV=0.0001
      CUTMUOTAV=0.0001
      BCUTMTAV=0.001
      DCUTMTAV=0.0001
      PPCUTMTAV=0.01
c end ml.
      PAIRTAV = 1
      COMPTAV = 1
      PHOTTAV = 1
      PFISTAV = 0
      DRAYTAV = 1
      ANNITAV = 1
      BREMTAV = 1
      HADRTAV = 4
      MUNUTAV = 1
      DCAYTAV = 1
      LOSSTAV = 1
      MULSTAV = 1
      RETURN
      END

*
* $Id: uglast.F,v 3.3 2005/12/05 12:15:20 pam-ba Exp $
*
* $Log: uglast.F,v $
* Revision 3.3  2005/12/05 12:15:20  pam-ba
* new spectrometer geometry and internal magnetic field
*
* Revision 3.2  2005/06/21 02:41:56  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               14/04/2005  13:08     by  Marialuigia Ambriola
*CMZ :  3.00/00 30/03/2001  14.16.15  by  Marialuigia Ambriola
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/02 12/03/96  16.29.41  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE UGLAST
************************************************************************
*                                                                      *
*            Termination routine to print histograms and statistics    *
*                                                                      *
* Called by: MAIN                                                      *
* Author: Francesco Cafagna, 30/11/95 16.32.17                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
#include "gpunit.inc"
C
#include "gcflag.inc"
#include "gpseed.inc"
C
C User action
C
      CALL GPULAS
C
      CALL GLAST
C
C             Save histograms
C
      IF (HBK) THEN
         CALL HROUT(0,ICYCLE,' ')
         CALL HREND('GPAMELA')
         CALL HPRINT(0)
      ENDIF
      CLOSE (LUHBK)
*.
#if defined(GPAMELA_HIGZ)
*
*             Close GKS display file
*
      CALL IGEND
#endif
C
C obsolete , now done in GPUINI
C
C Close magnetic field map
C
C      CLOSE (LUFMAP)
*
*ml 19/4/2004: (update and close the file that contains the seed of
*the random number generator.
      CLOSE(LUFSF)
      CALL GRNDMQ(NRNDM(1),NRNDM(2),0,'G')
c      print*,'glast:nrndm=',nrndm(1),nrndm(2)
      OUTSEED(3)=NRNDM(1)
      OUTSEED(4)=NRNDM(2)
C      WRITE(LULSF) NRNDM
      WRITE(LULSF) OUTSEED
c      PRINT*,'UGLAST: INSEED=',INSEED
c      PRINT*,'UGLAST: OUTSEED=',OUTSEED
      CLOSE(LULSF)
      END

*
* $Id: gpsitr.F,v 3.2 2006/03/15 16:22:52 bottai Exp $
*
* $Log: gpsitr.F,v $
* Revision 3.2  2006/03/15 16:22:52  bottai
*  Delta rays are disabled in SITR. Delta rays should not be simulated
* because at present the SPE strips are still not simulated and
* only the hits positions and their spread from true value (already
* taking into account the delta rays contribution) are simulated.
*
* Revision 3.1.1.1  2002/07/11 16:02:14  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.01/00 16/05/96  17.19.05  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  17.54.02  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   04/04/96
      SUBROUTINE GPSITR
************************************************************************
*                                                                      *
* To define special tracking parameters for tracker silicon            *
*                                                                      *
* Called by: GPDAT                                                     *
* Author: Francesco Cafagna, 04/04/96 17.41.17                         *
*                                                                      *
************************************************************************
#include "gpsitr.inc"
#include "gpkey.inc"
* Spectromiter silicon parameters from Paolo papini

      IF(HLONG) THEN 
       LOSSSITR=1.
       DRAYSITR=1.
      ELSE
       LOSSSITR=2.
       DRAYSITR=0.
      ENDIF

      DCUTESITR=0.00001
      DCUTMSITR=0.00001
      CUTELESITR=0.00001
      CUTMUOSITR=0.00001
      STRASITR=0.
      RETURN
      END

*
* $Id: gpukin.F,v 3.2 2005/12/14 03:12:43 cafagna Exp $
*
* $Log: gpukin.F,v $
* Revision 3.2  2005/12/14 03:12:43  cafagna
* Neutron detector added. Geometry and GPCALOR package
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  17.01.33  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   15/04/96
      SUBROUTINE GPUKIN(IFLAG)
************************************************************************
*                                                                      *
* User routine called in GUKINE to pass the control to GPAMELA user    *
* before and after VERTEX and KINE definitions                         *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  IFLAG = 1, before GSVERT and GSKINE calls in GUKINE                 *
*  IFLAG = 2, after  GSVERT and GSKINE calls in GUKINE                 *
*                                                                      *
* Called by: GUKINE                                                    *
* Author: Francesco Cafagna, 15/04/96 15.26.03                         *
*                                                                      *
************************************************************************
#include "gcflag.inc"
#include "gckine.inc"
#include "gconst.inc"
#include "gpkine.inc"
#include "gpgene.inc"
#include "gpkey.inc"
#include "gpgeo.inc"
            
      RETURN
      END

C*****This subroutine fills the common NeutronsGR: Number_N, Neut_En(3),
C     teta_n(3), fi_n(3),
C*****where
C*****Number_N - number of neutrons in case of Gigantic resonance
C     (Number_N=0, if no);
C*****NeutE_n(i) - energy of each generated neutron, MeV
C*****teta_n(i) - teta (polar) angle in reference coordinate system
C*****fi_n(i) - fi (azimuth) angle in reference coordinate system Input
C     parameters from GEANT: Step - GEANT step, cm En-gamma - gamma
C     energy in tungsten, GeV px_gamma, py_gamma, pz_gamma - gamma
C     momentum projections, GeV
      subroutine GPGRES(Step, En_g, px_g, py_g, pz_g)
      
      integer i
      real En_exc
      real cos_teta, sin_teta, cos_fi, sin_fi, En_n, alfa_n, beta_n
      
C     Input parameters
*     Energy of gamma, in GeV
      real En_gamma                     
*     Gamma momentum projections, multiplied by c, in GeV
      real px_gamma, py_gamma, pz_gamma 
*     GEANT step, in cm   
      real Step                         

      common/bind/En_bind(3)
#include "gpgneut.inc"
c     
*     
*     Let's trasnform energy and momentum in MeV. Remember, GEANT is GeV
*     
      open(77,file='testgig.dat',access='append')
      En_gamma=En_g/1000.
      px_gamma=px_g/1000.
      py_gamma=py_g/1000.
      pz_gamma=pz_g/1000.
*     
*     Exciting energy of nucleus in Gigantic resonance, MeV
      En_exc=En_gamma                   
      Number_N=0
      do i=1,3
         Neut_En(i)=0.
         teta_n(i)=0.
         fi_n(i)=0.
      enddo
      
C     Simulate number of neutrons in Gygantic resonance process
C     (Number_n=0 if no interaction)
      call GRESsimulate(En_gamma, Step, Number_N) 
      
      if (Number_N.gt.0) then
         cos_teta=pz_gamma/sqrt(px_gamma**2+py_gamma**2+pz_gamma**2)
         sin_teta=sqrt(1.-cos_teta**2)
         cos_fi=px_gamma/sqrt(px_gamma**2+py_gamma**2)
         sin_fi=py_gamma/sqrt(px_gamma**2+py_gamma**2)

         do i=1, Number_N
            if (En_exc.gt.En_bind(i)) then
               call SpectrumSpace(Number_N, i, En_exc,
     &              cos_teta, sin_teta, cos_fi, sin_fi, 
     &              En_n, alfa_n, beta_n)
               Neut_En(i)=En_n
               teta_n(i)=alfa_n
               fi_n(i)=beta_n
               En_exc=En_exc-En_bind(i)-En_n
            endif
         enddo

      endif
      write(77,*) Number_N, step, en_gamma
      close(77)      
      RETURN
      end

c************************************************************************
*************************************************************************
C*****Simulate generated number of
C*****neutrons
C******************************
      subroutine GRESsimulate(En_gamma, Step, Number_N)
c     Output parameter: Number_N (as default Number_N=0) 
      real En_gamma, Step
      integer Number_N
      
      real Sigma
      real*4 tmp
      real Lambda1, Lambda2, Lambda3         

#include "gpgsigma.inc"
      
      if ((En_gamma.gt.9.097).and.(En_gamma.lt.28.608)) then
CCCCC Calculate Lambda1
         Sigma=-1.      
         do i=1,63
            if ((En_gamma.ge.energy1(i)).and.(En_gamma.lt.energy1(i+1))) 
     &           Sigma=cross1(i)+(cross1(i+1)-cross1(i))*
     &           (En_gamma-energy1(i))/
     &           (energy1(i+1)-energy1(i))
         enddo
         if (Sigma.le.0.) then
            Lambda1=1000.
         else
 1          call GRNDM(tmp,1)
            if ((tmp.lt.1.E-8).or.(tmp.gt.(1.-1.E-8))) goto 1
            Lambda1=-log(1.-tmp)/(Sigma*1.E-27*6.31*1.E22)
         endif
CCCCCCCalculate Lambda2
         Sigma=-1.
         do i=1,61
            if ((En_gamma.ge.energy2(i)).and.(En_gamma.lt.energy2(i+1)))
     &           Sigma=cross2(i)+(cross2(i+1)-cross2(i))*
     &           (En_gamma-energy2(i))/
     &           (energy2(i+1)-energy2(i))
         enddo
         if (Sigma.le.0.) then
            Lambda2=1000.
         else
 2          call GRNDM(tmp,1)
            if ((tmp.lt.1.E-8).or.(tmp.gt.(1.-1.E-8))) goto 2      
            Lambda2=-log(1.-tmp)/(Sigma*1.E-27*6.31*1.E22)      
         endif              
         
CCCCCCCalculate Lambda3
         Sigma=-1.
         do i=1,26
            if ((En_gamma.ge.energy3(i)).and.(En_gamma.lt.energy3(i+1)))
     &           Sigma=cross3(i)+(cross3(i+1)-cross3(i))*
     &           (En_gamma-energy3(i))/
     &           (energy3(i+1)-energy3(i))
         enddo
         if (Sigma.le.0.) then
            Lambda3=1000.
         else
 3          call GRNDM(tmp,1)
            if ((tmp.lt.1.E-8).or.(tmp.gt.(1.-1.E-8))) goto 3      
            Lambda3=-log(1.-tmp)/(Sigma*1.E-27*6.31*1.E22)         
         endif
         
         if (Lambda1.eq.MIN(Lambda1, Lambda2, Lambda3, Step)) Number_N=1
         if (Lambda2.eq.MIN(Lambda1, Lambda2, Lambda3, Step)) Number_N=2      
         if (Lambda3.eq.MIN(Lambda1, Lambda2, Lambda3, Step)) Number_N=3
      endif
      RETURN
      end

c************************************************************************
c************************************************************************
******Simulate neutron energy and flight direction*********************** 

      subroutine SpectrumSpace(Number_N, Num, En_exc,
     &     cos_teta, sin_teta, cos_fi, sin_fi, En_n, alfa_n, beta_n)
c     Output parameters: En_n, alfa_n, beta_n
      common/bind/En_bind(3)

      real tmp(2)     
      real Pi, Temperature, lev_dens, cos_alfa, sin_alfa, beta
      real cos_alfa_n, cos_beta_n, sin_beta_n
      integer Number_N, Num 
      
      real En_exc
      real cos_teta, sin_teta, cos_fi, sin_fi, En_n, alfa_n, beta_n

      Pi=4.*atan(1.)	
      if (Number_N.eq.1) then
         En_n=En_exc-En_bind(1)

      else if ((Number_N.eq.2).and.(Num.eq.1)) then
C************************************************************************
C     SIMULATION OF NEUTRON EVAPORATION SPECTRUM The reference book
C     is: V.C. Barashenkov, V.D. Toneev, "The interactions of high
C     energy particles and atomic nuclei with nuclei", in Russian
C     Calculation of density levels parameter (see (6.31) from reference
C     book)
         lev_dens=0.085*184.
C     Calculation of nucleus temperature (see (6.30) from reference book)
C     (see (6.64) and comments after)       
         Temperature=sqrt((En_exc-En_bind(Num))/lev_dens) 
         
C     Neutron evaporation energy spectrum simulation by exception method
 4       call GRNDM(tmp,2)
C     The average binding energy of neutron
         x_tmp=(En_exc-En_bind(1)-En_bind(2))*tmp(1) 
         y_tmp=(exp(-1.)/Temperature)*tmp(2)
         if (y_tmp.gt.((x_tmp/Temperature**2)*exp(-x_tmp/Temperature)))
     &        goto 4
         En_n=x_tmp
      else if ((Number_N.eq.2).and.(Num.eq.2)) then
         En_n=En_exc-En_bind(2)
      else if ((Number_N.eq.3).and.(Num.eq.1)) then
C************************************************************************
C     SIMULATION OF NEUTRON EVAPORATION SPECTRUM The reference book is:
C     V.C. Barashenkov, V.D. Toneev, "The interactions of high energy
C     particles and atomic nuclei with nuclei", in Russian Calculation
C     of density levels parameter (see (6.31) from reference book)
         lev_dens=0.085*184.
C     Calculation of nucleus temperature (see (6.30) from reference book)
C     (see (6.64) and comments after)       
         Temperature=sqrt((En_exc-En_bind(Num))/lev_dens) 

C     Neutron evaporation energy spectrum simulation by exception method
 5       call GRNDM(tmp,2)
C     Average binding energy of neutron
         x_tmp=(En_exc-En_bind(1)-En_bind(2)-En_bind(3))*tmp(1)
         y_tmp=(exp(-1.)/Temperature)*tmp(2)
         if (y_tmp.gt.((x_tmp/Temperature**2)*exp(-x_tmp/Temperature)))
     &        goto 5
         En_n=x_tmp
         
      else if ((Number_N.eq.3).and.(Num.eq.2)) then
C************************************************************************
C     SIMULATION OF NEUTRON EVAPORATION SPECTRUM The reference book
C     is: V.C. Barashenkov, V.D. Toneev,  "The interactions of high
C     energy particles and atomic nuclei with nuclei", in Russian
C     Calculation of density levels parameter (see (6.31) from reference
C     book) 
         lev_dens=0.085*183.
C     Calculation of nucleus temperature (see (6.30) from reference book)
C     (see (6.64) and comments after)       
         Temperature=sqrt((En_exc-En_bind(Num))/lev_dens) 
         
C     Neutron evaporation energy spectrum simulation by exception method
 6       call GRNDM(tmp,2)
C     Average binding energy of neutron
         x_tmp=(En_exc-En_bind(2)-En_bind(3))*tmp(1)
         y_tmp=(exp(-1.)/Temperature)*tmp(2)
         if (y_tmp.gt.((x_tmp/Temperature**2)*exp(-x_tmp/Temperature)))
     &        goto 6
         En_n=x_tmp
         
      else if ((Number_N.eq.3).and.(Num.eq.3)) then
         En_n=En_exc-En_bind(3)
         
      endif
C************************************************************************
C     Neutron direction simulation in gamma coordinate system
      call GRNDM(tmp,2)
      cos_alfa=-1.+2.*tmp(1)
      beta=2.*Pi*tmp(2)
      sin_alfa=sqrt(1.-cos_alfa**2)
C     Return to the GEANT reference coordinate system
      cos_alfa_n=-sin_alfa*cos(beta)*(sin_teta)+cos_alfa*(cos_teta)
      cos_beta_n=sin_alfa*cos(beta)*(cos_teta*cos_fi)-
     &     sin_alfa*sin(beta)*(sin_fi)+cos_alfa*(sin_teta*cos_fi)
      sin_beta_n=sin_alfa*cos(beta)*(cos_teta*sin_fi)+
     &     sin_alfa*sin(beta)*(cos_fi)+cos_alfa*(sin_teta*sin_fi)
      if (abs(cos_beta_n).lt.1.E-6) cos_beta_n=0.
      if (abs(sin_beta_n).lt.1.E-6) sin_beta_n=0.
      if ((cos_beta_n.eq.0.).and.(sin_beta_n.eq.0.)) beta_n=0.
      
      alfa_n=acos(cos_alfa_n)
      if ((cos_beta_n.ge.0.).and.(sin_beta_n.gt.0.)) 
     &     beta_n=atan(sin_beta_n/cos_beta_n)
      if ((cos_beta_n.ge.0.).and.(sin_beta_n.lt.0.))
     &     beta_n=2.*Pi+atan(sin_beta_n/cos_beta_n)     
      if ((cos_beta_n.lt.0.).and.(sin_beta_n.le.0.))
     &     beta_n=Pi+atan(sin_beta_n/cos_beta_n)      
      if ((cos_beta_n.lt.0.).and.(sin_beta_n.ge.0.))
     &     beta_n=Pi+atan(sin_beta_n/cos_beta_n)             
      
      RETURN
      END

*
* $Id: gpgeo.F,v 3.15 2006/11/16 18:45:28 pam-ba Exp $
*
* $Log: gpgeo.F,v $
* Revision 3.15  2006/11/16 18:45:28  pam-ba
* Simulated an aluminum container for S4
*
* Revision 3.14  2006/11/16 12:01:12  pam-ba
* S4 dimensions corrected.
*
* Revision 3.13  2006/11/10 11:39:33  pam-ba
* S2 and S1 z-positions corrected, He3 and plystyrene mixture added, Top Plate geometry simulated and titanium mixture added.
*
* Revision 3.12  2006/10/12 11:11:20  pam-ba
* ND geometry updated.
*
* Revision 3.11  2006/10/02 11:17:29  pam-ba
* NDET 'SPHE' data card meaning changed. Now it eliminates the whole PAMELA container.
*
* Revision 3.10  2006/05/18 10:52:31  pam-ba
* TOF geometry completed and a new material, the polystyrene (density 35 g/l), added
*
* Revision 3.9  2006/05/02 15:23:14  cafagna
* Few mispelled command in gpgeo.inc and gpgeo.F
*
* Revision 3.8  2006/05/02 11:07:05  pam-ba
* TOF geometry and position updated and a new material, the mylar, added
*
* Revision 3.7  2006/04/09 23:28:33  cafagna
* Several new things, among this: ND and CARD
*
* Revision 3.6  2005/12/14 03:12:41  cafagna
* Neutron detector added. Geometry and GPCALOR package
*
* Revision 3.5  2005/12/05 12:15:20  pam-ba
* new spectrometer geometry and internal magnetic field
*
* Revision 3.4  2005/07/25 11:53:20  cafagna
* Several updates. See history for details
*
* Revision 3.3  2005/06/21 02:41:47  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2002/12/04 15:12:54  pamela
* CAS and CALO geometry modified
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               16/07/2004  16.44.06  by  Alexey Bakaldin
*               15/10/2002  15.29.36  by  Jens Lund
*CMZ :  3.00/00 13/11/2000  09.03.11  by  Emiliano Mocchiutti
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 08/11/99  18.44.50  by  Francesco Cafagna
*CMZ :  1.01/00 13/05/96  09.16.26  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  12.00.53  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPGEO
************************************************************************
*                                                                      *
* Volumes definition for PAMELA                                        *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/95 13.21.27                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpkey.inc"
#include "gprot.inc"
#include "gpdrot.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
*  Define 90 degree rotation around Z axis
*
      CALL GSROTM(RZ90,90.,90.,90.,180.,0.,0.)
*
*  Define 90 degree rotation around X axis
*
      CALL GSROTM(RX90,90.,0.,180.,90.,90.,90.)
*
*  Define 90 degree rotation around Z axis and 180 along X
*
      CALL GSROTM(RZ90X180,90.,90.,90.,360.,180.,0.)
*
*  Define 180 degree rotation around Z axis
*
      CALL GSROTM(RZ180,90.,180.,90.,270.,0.,0.)
*JeL:
*
*  Define 180 degree rotation aroun Z axis and 180 along X
*
      CALL GSROTM(RZ180X180,90.,180.,90.,90.,180.,0.)
*
*  Define 270 degree rotation around Z axis
*
      CALL GSROTM(RZ270,90.,270.,90.,360.,0.,0.)
*
*  Define 90 degree rotation around Y axis
*
      CALL GSROTM(RY90,0.,0.,90.,90.,90.,180.)
*
*  Define 270 degree rotation around Y axis
*
      CALL GSROTM(RY270,180.,0.,90.,90.,90.,0.)
*
*  Define 180 degree rotation around Y axis
*
      CALL GSROTM(RY180,90.,180.,90.,90.,180.,0.)
*
*  Define 180 degree rotation around X axis
*
      CALL GSROTM(RX180,90.,0.,90.,270.,180.,0.)

*END: JeL.
*
*  Define the PAMELA   volume
*
      NMED=MN2
      CALL GSVOLU('PAME','TUBE',NMED,PAME, 3,IVOLU)
*AB:
*
*  Define the Aluminium shell volumes
*
      NMED=MAL
C      CALL GSVOLU('SHEL','TUBE',NMED,SHEL, 3,IVOLU)
      CALL GSVOLU('SHEL','CONE',NMED,SHEL, 5,IVOLU)
*
*  Define the Aluminium inner shell volumes
*
      IF(SPH) THEN
         NMED=MAL
         CALL GSVOLU('TSPH','SPHE',NMED,TSPH, 6,IVOLU)
c      ELSE
c         NMED=MAL
c         CALL GSVOLU('TFLA','TUBE',NMED,TFLA, 3,IVOLU)
c      ENDIF
*
*  Define the Aluminium shell volumes
*
         NMED=MAL
         CALL GSVOLU('MSHE','TUBE',NMED,MSHE, 3,IVOLU)
*
*  Define the Aluminium shell volumes
*
         NMED=MAL
         CALL GSVOLU('BSPH','SPHE',NMED,BSPH, 6,IVOLU)
*END: AB.
c ml: 28/10/04 
      ENDIF
*
*  Define the top plate  
*
c      NMED=MTAV
      NMED=MN2
      CALL GSVOLU('TPLA','BOX ',NMED,TPLA, 3,IVOLU)
      NMED=MTAV
      CALL GSVOLU('TPTU','BOX ',NMED,TPTU,3,IVOLU)
      NMED=MTAV
      CALL GSVOLU('TPTM','BOX ',NMED,TPTM,3,IVOLU)
      NMED=MTAV
      CALL GSVOLU('TPTL','BOX ',NMED,TPTL,3,IVOLU)
      NMED=MN2
      CALL GSVOLU('TPCV','BOX ',NMED,TPCV,3,IVOLU)
*
* Volume definition for scintillators, TOF and anticoincidence counter
*
      IF(TOF ) CALL GPTOFV
      IF(CAT ) CALL GPCATV
      IF(CAS ) CALL GPCASV
      IF(CARD) CALL GPCARDV
*
* Volume definition for TRD
*
      IF(TRD ) CALL GPTRDV
*
* Volume definition for Spectrometer
*
      IF(SPE ) CALL GPSPEV
*
* Volume definition for Calorimeter
*
      IF(CAL ) CALL GPCALV
*
* Volume definition for ND
*
      IF(ND  ) CALL GPNDV
*
*  Volume positioning starting from the TOP
*
      IF(SPH) THEN
         X= 0.
         Y= 0.
*
* Positioning volume SHEL     into the mother PAME
*
         N= 1
         Z= ZSHEL
         CALL GSPOS('SHEL',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume SHEI     into the mother PAME
*
C         N= 1
C         Z= ZSHEI
c         CALL GSPOS('SHEI',N,'PAME',X,Y,Z,0,'ONLY')
C         IF(SPH) THEN
*
* Positioning volume TSPH     into the mother PAME
*
         N= 1
         Z= ZTSPH
         CALL GSPOS('TSPH',N,'PAME',X,Y,Z,0,'ONLY')
C      ELSE
C*
C* Positioning volume TFLA     into the mother PAME
C*
C         N= 1
C         Z= ZTFLA
C         CALL GSPOS('TFLA',N,'PAME',X,Y,Z,0,'ONLY')
C      ENDIF
*AB:
*
* Positioning volume MSHE     into the mother PAME
*
         N= 1
         Z= ZMSHE
         CALL GSPOS('MSHE',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume BSPH     into the mother PAME
*
         N= 1
         Z= ZBSPH
         CALL GSPOS('BSPH',N,'PAME',X,Y,Z,0,'ONLY')
* END: AB.
      ENDIF
*
* Positioning volume S1     into the mother PAME
*
      N= 1
c$$$<<<<<<< gpgeo.F
      Z= ZS1
      IF(TOF) CALL GSPOS('S1  ',N,'PAME',X,Y,Z,0,'ONLY')
c$$$=======
c$$$c ml:24/11/04
c$$$cc      Z=ZCAL+CALS(3)+ZSPEBP+2*(SPEB(3)+TPLA(3)+S22(3)+S21(3)+CATA(2))+ 
c$$$cc     +     2*TRDB(3)+2*S12(3)+S11(3)
c$$$cc      print*,'gpgeo: xs11, ys11, zs11=',x,y,z
c$$$C      Z= ZS11
c$$$cc      IF(TOF) CALL GSPOS('S11 ',N,'PAME',X,Y,Z,0,'ONLY')
c$$$>>>>>>> 3.7
c$$$c end ml.
*
* Positioning volume S2     into the mother PAME
*
c      N= 1
c$$$<<<<<<< gpgeo.F
C ML:
C      Z= ZS2
C      IF(TOF) CALL GSPOS('S2  ',N,'PAME',X,Y,Z,0,'ONLY')
CC      Z=-TPS2(3)+S2(3)
CC      IF(TOF) CALL GSPOS('S2  ',N,'TPS2',X,Y,Z,0,'ONLY')
c$$$=======
c$$$c ml:24/11/04
c$$$cc      Z=ZCAL+CALS(3)+ZSPEBP+2*(SPEB(3)+TPLA(3)+S22(3)+S21(3)+CATA(2))+ 
c$$$cc     +     2*TRDB(3)+S12(3)
c$$$C      Z= ZS12
c$$$cc      print*,'gpgeo: xs12, ys12, zs12=',x,y,z
c$$$cc      IF(TOF) CALL GSPOS('S12 ',N,'PAME',X,Y,Z,0,'ONLY')
c$$$>>>>>>> 3.7
c$$$c end ml.
*
* Positioning volume TRDB     into the mother PAME
*
      IF(TRD) THEN
         N= 1
         Z= ZTRD
         CALL GSPOS('TRDB',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
C FC commented out on 21-10-1999 by caf
c         CALL GSPOS('TRDS',N,'PAME',X,Y,Z,0,'ONLY')
c         Z= ZTRD - TRDS(3) - TRDT(3)
c         CALL GSPOS('TRDT',N,'PAME',X,Y,Z,0,'ONLY')
c         N= 2
c         Z= ZTRD + TRDS(3) + TRDT(3)
c         CALL GSPOS('TRDT',N,'PAME',X,Y,Z,0,'ONLY')
C FC end of comment on 21-10-1999
      ENDIF
*
* Positioning volume CARD    into the mother PAME
*
      IF(CARD) THEN
         N=1
         X=0
         Y=0
         Z=ZTPLA+TPLA(3)+CARDB(3)
         CALL GSPOS('CARD',N,'PAME',X,Y,Z,0,'ONLY')
      ENDIF

c$$$*
c$$$* Positioning volume S21     into the mother PAME
c$$$*
c$$$      N= 1
c$$$c ml:24/11/04
c$$$      Z=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+2*TPLA(3)+2*S22(3)+S21(3)
c$$$c      Z= ZS21
c$$$      print*,'gpgeo: xs21, ys21, zs21=',x,y,z
c$$$      IF(TOF) CALL GSPOS('S21 ',N,'PAME',X,Y,Z,0,'ONLY')
c$$$c  end ml.
c$$$*
c$$$* Positioning volume S22     into the mother PAME
c$$$*
c$$$      N= 1
c$$$c ml:24/11/04
c$$$      Z=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+2*TPLA(3)+S22(3)
c$$$c      Z= ZS22
c$$$      print*,'gpgeo: xs22, ys22, zs2=',x,y,z
c$$$      IF(TOF) CALL GSPOS('S22 ',N,'PAME',X,Y,Z,0,'ONLY')
c$$$c end ml.
c$$$>>>>>>> 3.7
c ml: 28/10/04
*
*  Positioning volume TPLA into the mother PAME
*
      N=1
      X=0.
      Y=0.
      Z=ZTPLA
      CALL GSPOS('TPLA',N,'PAME',X,Y,Z,0,'ONLY')
      Z=-TPLA(3)+TPTL(3)
      CALL GSPOS('TPTL',N,'TPLA',X,Y,Z,0,'ONLY')
      Z=0.
      CALL GSPOS('TPCV',N,'TPTL',X,Y,Z,0,'ONLY')
      N=1
      Z=-TPLA(3)+2*TPTL(3)+S2(3)
      CALL GSPOS('S2  ',N,'TPLA',X,Y,Z,0,'ONLY')
      N=0
      Z=-TPLA(3)+2*TPTL(3)+S2(3)
      DO I=1,4
         N=N+1
         IF(MOD(I,2).EQ.1) THEN
            Y=-(YTPLA-TPTM(2))
            IF(I.EQ.1) X=-(XTPLA-TPTM(1))
            IF(I.EQ.3) X=(XTPLA-TPTM(1))
         ELSE
            Y=(YTPLA-TPTM(2))
            IF(I.EQ.2) X=-(XTPLA-TPTM(1))
            IF(I.EQ.4) X=(XTPLA-TPTM(1))
         ENDIF
         CALL GSPOS('TPTM',N,'TPLA',X,Y,Z,0,'ONLY')  
      ENDDO
      N=1
      X=0.
      Y=0.
      Z=TPLA(3)-CATA(2)
      CALL GSPOS('CATA',N,'TPLA',X,Y,Z,2,'ONLY')
      N=0
      Z=TPLA(3)-TPTU(3)
      DO I=1,4
         N=N+1
         IF(MOD(I,2).EQ.1) THEN
            Y=-(YTPLA-TPTU(2))
            IF(I.EQ.1) X=-(XTPLA-TPTU(1))
            IF(I.EQ.3) X=(XTPLA-TPTU(1))
         ELSE
            Y=(YTPLA-TPTU(2))
            IF(I.EQ.2) X=-(XTPLA-TPTU(1))
            IF(I.EQ.4) X=(XTPLA-TPTU(1))
         ENDIF
         CALL GSPOS('TPTU',N,'TPLA',X,Y,Z,0,'ONLY')
      ENDDO
      X=0.
      Y=0.
*JeL:
*
* Positioning volume CATA     into the mother PAME
*
      N= 1
C ML      Z= ZCAT
C Com. by JeL IF(CAT) CALL GSPOS('CATB',N,'PAME',X,Y,Z,0,'ONLY')
C ML:      IF(CAT) CALL GSPOS('CATA',N,'PAME',X,Y,Z,2,'ONLY')
C      Z=0.
C      IF(CAT) CALL GSPOS('CATA',N,'TPCA',X,Y,Z,2,'ONLY')
c end ml.
*END: JeL.
*
* Positioning volume CAS      into the mother PAME
*
*EM:
*JeL:
C      Z= ZCAS
c       Z= ZSPEC-2.1
      Z=ZCAS
*end JeL.
      IF(CAS) THEN
*com by JeL:
CC         X = 0
C         N = 0
C         DO I = 1,2
C            X = ((-1)**(I+1))*CASXD
CC            Y = ((-1)**I)*( CASY(2) + CASX(2) )
C            Y = ((-1)**I)*CASY(2)
Cc fc mod by caf on 21-10-1999
Cc            DO II=1, 5
Cc               Z = ZCAS - 4.*CASX(3) + (II-1) * 2*CASX(3)
Cc               N = N + 1
Cc               CALL GSPOS('CASX',N,'PAME',X,Y,Z,0,'ONLY')
Cc            ENDDO
Cc fc end mod
C            Z = ZCAS
C            N = N + 1
C*
C            CALL GSPOS('CSSX',N,'PAME',X,Y,Z,0,'ONLY')
C         ENDDO
C*
CC         Y = 0
C         N = 0
C         DO I = 1,2
C            X = ((-1)**I)*(CASX(1)+0.1)
CC            X = ((-1)**I)*(CASX(1)+CASY(1))
C            Y = ((-1)**I)*CASYD
Cc fc mod by caf on 21-10-1999
Cc            DO II=1, 5
Cc               Z = ZCAS - 4.*CASY(3) + (II-1) * 2*CASY(3)
Cc               N = N + 1
Cc               CALL GSPOS('CASY',N,'PAME',X,Y,Z,0,'ONLY')
Cc            ENDDO
Cc fc end mod
C            Z = ZCAS
C            N = N + 1
C            CALL GSPOS('CSSY',N,'PAME',X,Y,Z,0,'ONLY')
C         ENDDO
*end com by JeL.
*JeL:
         N = 1
*ML:
C         X = 10.75
         X = 8.872
C         Y = -14.1
         Y = -17.215
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,0,'ONLY')
         N = 2
*ML:
C         X = 14.1
         X = 17.9285
C         Y = 10.75
         Y = 6.305
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,1,'ONLY')
         N = 3
*ML:
C         X = -10.75
         X = -5.5095
C         Y = 14.1
         Y = 17.215
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,4,'ONLY')
         N = 4
*ML:
C         X = -14.1
         X = -17.9285
C         Y = -10.75
         Y = -10.195
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,6,'ONLY')
*end JeL.
      ENDIF
*END: EM.
*
* Positioning volume SPEB     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZSPEC
      IF(SPE) CALL GSPOS('SPEB',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume S3     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZS3
      IF(TOF) CALL GSPOS('S3  ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume CALB     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZCAL
      IF(CAL) CALL GSPOS('CALS',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S4AL     into the mother PAME
*
      N= 1
      Z= ZS4
      IF(TOF) CALL GSPOS('S4AL',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume NDBO    into the mother PAME
*
      N=1
c      Z=ZCAL-CALS(3)-2*S4(3)-8.
      Z=ZND
C      IF(ND ) CALL GSPOS('NDBX',N,'PAME',X,Y,Z,0,'ONLY')
      IF(ND ) CALL GSPOS('NDBO',N,'PAME',X,Y,Z,0,'ONLY')
*
* User action
*
      CALL GPUGEO
      RETURN
      END

      SUBROUTINE GPCARDV
************************************************************************
*                                                                      *
* Volumes definition for the side anticoincidence counters             *
* Called by: GPGEO                                                     *
*                                                                      *
* Authors: Francesco Cafagna, 08/02/96 16.58.49                        *
*          Alessandro Bruno, 20/11/06 20.30.00                         *
*                                                                      *
************************************************************************
#include "gconst.inc"
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gprot.inc"
      INTEGER IROT,IVOLU,N,NMED,NUM,I
      REAL X,Y,Z
      REAL CAR1(11),CR1P(11)
      REAL C1D1(11),C2D1(11)
      REAL CAR2(11),CR2P(11)
      REAL C1N1(11),C1N2(11)
      REAL ANGLCAR1,ANGLCAR2
      REAL H1,H2
      REAL A1,B1,C1,D1,F1,ANG1C
      REAL A2,B2,C2,D2,F2,ANG2C
      REAL AA, BB,ZH
*
* Scint sheets
*      
      H1=CAR(2)+CAR(3)
      H2=CAR(1)-H1
*
* Greater Scintillator CAR1 (type B)
*           
      B1=CARB(2)+CAR(4)+CAR(5)+H1/TAN(CAR(7)*DEGRAD)
      C1=H2/TAN(CAR(7)*DEGRAD)
      A1=CARB(1)-C1
      D1=CARB(1)-CARB(2)-CAR(4)-CAR(5)
      F1=C1+H1/TAN(CAR(7)*DEGRAD)
      ANG1C=ATAN((B1/2.+D1-A1/2.)/CAR(1))
      
      C1D1(1) = CAR(1)/2.
      C1D1(2) = -ANG1C*RADDEG
      C1D1(3) = 0.
      C1D1(4) = CAR(6)
      C1D1(5) = A1/2.
      C1D1(6) = A1/2.
      C1D1(7) = 0.
      C1D1(8) = CAR(6)
      C1D1(9) = B1/2.
      C1D1(10) = B1/2.
      C1D1(11) = 0.
      
*      
* Smaller Scintillator CAR2 (type A)
*           
      B2=CARA(2)+CAR(4)+CAR(5)+H1/TAN(CAR(7)*DEGRAD)
      C2=H2/TAN(CAR(7)*DEGRAD)
      A2=CARA(1)-C2
      D2=CARA(1)-CARA(2)-CAR(4)-CAR(5)
      F2=C2+H1/TAN(CAR(7)*DEGRAD)
      ANG2C=ATAN((B2/2.+D2-A2/2.)/CAR(1))

      C2D1(1) = CAR(1)/2.
      C2D1(2) = -ANG2C*RADDEG
      C2D1(3) = 0.
      C2D1(4) = CAR(6)
      C2D1(5) = A2/2.
      C2D1(6) = A2/2.
      C2D1(7) = 0.
      C2D1(8) = CAR(6)
      C2D1(9) = B2/2.
      C2D1(10) = B2/2.
      C2D1(11) = 0.
*
* CAR1 Al box sheet
*
      NMED=MAL
      
      CAR1(1) = C1D1(1)+ATZ
      CAR1(2) = C1D1(2)
      CAR1(3) = 0.
      CAR1(4) = C1D1(4)+ATY
      CAR1(5) = C1D1(5)+ATZ*(1./COS(ATAN(D1/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CAR1(6) = CAR1(5)
      CAR1(7) = 0.
      CAR1(8) = C1D1(8)+ATY
      CAR1(9) = C1D1(9)+ATZ*(1./COS(ATAN(D1/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CAR1(10) = CAR1(9)
      CAR1(11) = 0.

      CALL GSVOLU('CAR1','TRAP',NMED,CAR1,11,IVOLU)
*
* CR1P PLASTIC BOX TO CREATE RIM 
*
      NMED=MPLAS
      
      CR1P(1) = C1D1(1)+PT
      CR1P(2) = C1D1(2)
      CR1P(3) = 0.
      CR1P(4) = C1D1(4)
      CR1P(5) = C1D1(5)+PT*(1./COS(ATAN(D1/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CR1P(6) = CR1P(5)
      CR1P(7) = 0.
      CR1P(8) = C1D1(8)
      CR1P(9) = C1D1(9)+PT*(1./COS(ATAN(D1/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CR1P(10) = CR1P(9)
      CR1P(11) = 0.
      
      CALL GSVOLU('CR1P','TRAP',NMED,CR1P,11,IVOLU)
*
      NMED=MSCIN
*
      CALL GSVOLU('C1D1','TRAP',NMED,C1D1,11,IVOLU)
*
* Empty volume to be subtracted from C1D1 and C2D1 sheets
*
      NMED=MN2
      
      AA=(ATZ/SIN(DEGRAD*CAR(7)))/(1./TAN(CAR(7)*DEGRAD)+CAR(4)/CAR(2))
      AA=CAR(2)+CAR(3)+ATZ+AA
      BB=AA/TAN(CAR(7)*DEGRAD)+AA*CAR(4)/CAR(2)
            
      C1N1(1) = 0.5*AA
      C1N1(2) = RADDEG*ATAN((BB/2.-AA/TAN(CAR(7)*DEGRAD))/AA)
      C1N1(3) = 0.
      C1N1(4) = CAR1(4)
      C1N1(5) = 0.
      C1N1(6) = C1N1(5)
      C1N1(7) = 0.
      C1N1(8) = CAR1(8)
      C1N1(9) = 0.5*BB
      C1N1(10) = C1N1(9)
      C1N1(11) = 0.
      
      CALL GSVOLU('C1N1','TRAP',NMED,C1N1,11,IVOLU)

      AA=CAR(3) + ATZ
      BB=(ATZ+CAR(3))*(CAR(5)/CAR(3)-CAR(4)/CAR(2))
 
      C1N2(1) = 0.5*AA
      C1N2(2) = RADDEG*ATAN((BB/2.+(CAR(3)+ATZ)*CAR(4)/CAR(2))/AA)
      C1N2(3) = 0.
      C1N2(4) = CAR1(4)
      C1N2(5) = 0.
      C1N2(6) = C1N2(5)
      C1N2(7) = 0.
      C1N2(8) = CAR1(8)
      C1N2(9) = 0.5*BB
      C1N2(10) = C1N2(9)
      C1N2(11) = 0.
      
      CALL GSVOLU('C1N2','TRAP',NMED,C1N2,11,IVOLU)
*
* CAR2 Al box sheet
*
      NMED=MAL
      
      CAR2(1) = C2D1(1)+ATZ
      CAR2(2) = C2D1(2)
      CAR2(3) = 0.
      CAR2(4) = C2D1(4)+ATY
      CAR2(5) = C2D1(5)+ATZ*(1./COS(ATAN(D2/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CAR2(6) = CAR2(5)
      CAR2(7) = 0.
      CAR2(8) = C2D1(8)+ATY
      CAR2(9) = C2D1(9)+ATZ*(1./COS(ATAN(D2/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CAR2(10) = CAR2(9)
      CAR2(11) = 0.
            
      CALL GSVOLU('CAR2','TRAP',NMED,CAR2,11,IVOLU)
*
* CR1P PLASTIC BOX TO CREATE RIM 
*
      NMED=MPLAS

      CR2P(1) = C2D1(1)+PT
      CR2P(2) = C2D1(2)
      CR2P(3) = 0.
      CR2P(4) = C2D1(4)
      CR2P(5) = C2D1(5)+PT*(1./COS(ATAN(D2/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CR2P(6) = CR2P(5)
      CR2P(7) = 0.
      CR2P(8) = C2D1(8)
      CR2P(9) = C2D1(9)+PT*(1./COS(ATAN(D2/CAR(1)))+
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      CR2P(10) = CR2P(9)
      CR2P(11) = 0.
      
      CALL GSVOLU('CR2P','TRAP',NMED,CR2P,11,IVOLU)
*
      NMED=MSCIN
*     
      CALL GSVOLU('C2D1','TRAP',NMED,C2D1,11,IVOLU)
*
*
* The zenihtal angle of the paddles
*
      ANGLCAR2=CARA(3)*DEGRAD   !CAR2 inclination
      ANGLCAR1=CARB(3)*DEGRAD   !CAR1 inclination

      NMED=MN2
      CALL GSVOLU('CARD','BOX ',NMED,CARDB, 3,IVOLU)
*
*  Define ANGLCAR rotation around Z axis
*
*    CAR1A
      IRZCAR1B=11
      CALL GSROTM(IRZCAR1B,90.,0.,(90.-ANGLCAR1*RADDEG),
     +     90.,(180.-ANGLCAR1*RADDEG),90.)
*    CAR1B
      IRZCAR1A=12
      CALL GSROTM(IRZCAR1A,90.,180.,(270.-ANGLCAR1*RADDEG),
     +     270.,(180.-ANGLCAR1*RADDEG),270.)
*    CAR2A
      IRZCAR2B=13
      CALL GSROTM(IRZCAR2B,90.,270.,(90.-ANGLCAR2*RADDEG),
     +     0.,(180.-ANGLCAR2*RADDEG),0.)
*    CAR2B
      IRZCAR2A=14
      CALL GSROTM(IRZCAR2A,90.,90.,(90.-ANGLCAR2*RADDEG),
     +     180.,(180.-ANGLCAR2*RADDEG),180.)

*
* Positioning in CAR1
*
      N=1
      X=(ATZ-PT)*(1./COS(ATAN(D1/CAR(1)))-
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      Y=0
      Z=0
      CALL GSPOS('CR1P',N,'CAR1',X,Y,Z,0,'MANY')
      N=1
      Y=0
      Z=CAR1(1)-C1N1(1)
      X=CAR1(9)+CAR1(1)*TAN(ANG1C)-
     +     (C1N1(9)-C1N1(1)*TAN(C1N1(2)*DEGRAD))
      X=-X !ALEX MOD 
      CALL GSPOS('C1N1',N,'CAR1',X,Y,Z,0,'ONLY')
      N=1
      Y=0
      Z=CAR1(1)-C1N2(1)
      X=CAR1(9)+CAR1(1)*TAN(ANG1C)-
     +     (2.*C1N1(9)+C1N2(9)-C1N2(1)*TAN(C1N2(2)*DEGRAD))
      X=-X !ALEX MOD 
      CALL GSPOS('C1N2',N,'CAR1',X,Y,Z,0,'ONLY')
      N=1
      X=PT*(1./COS(ATAN(D1/CAR(1)))-1./SIN(DEGRAD*CAR(7)))/2.
      Y=0
      Z=0
      CALL GSPOS('C1D1',N,'CR1P',X,Y,Z,0,'ONLY')
*
* Positioning in CAR2
*
      N=1
      X=(ATZ-PT)*(1./COS(ATAN(D2/CAR(1)))-
     +                       1./SIN(DEGRAD*CAR(7)))/2.
      Y=0
      Z=0
      CALL GSPOS('CR2P',N,'CAR2',X,Y,Z,0,'MANY')
      N=2
      Y=0
      Z=CAR2(1)-C1N1(1)
      X=CAR2(9)+CAR2(1)*TAN(ANG2C)-
     +     (C1N1(9)-C1N1(1)*TAN(C1N1(2)*DEGRAD))
      X=-X !ALEX MOD 
      CALL GSPOS('C1N1',N,'CAR2',X,Y,Z,0,'ONLY')
      Y=0
      Z=CAR2(1)-C1N2(1)
      X=CAR2(9)+CAR2(1)*TAN(ANG2C)-
     +     (2.*C1N1(9)+C1N2(9)-C1N2(1)*TAN(C1N2(2)*DEGRAD))
      X=-X !ALEX MOD 
      CALL GSPOS('C1N2',N,'CAR2',X,Y,Z,0,'ONLY')
      N=1
      X=PT*(1./COS(ATAN(D2/CAR(1)))-1./SIN(DEGRAD*CAR(7)))/2.
      Y=0
      Z=0
      CALL GSPOS('C2D1',N,'CR2P',X,Y,Z,0,'ONLY')
*
* Positioning in card
*
*
*           CAR1A
* CAR2B                CAR2A
*           CAR1B
*
      ZH=49.229-ZTPLA-TPLA(3)
*--- CAR1B      
      N=1
      Y=-CARB(5)+CAR(8)/2.*SIN(ANGLCAR1)
      Z=CARB(6)+ZH-CARDB(3)-CAR(8)*COS(ANGLCAR1)/2.
      X=((CARB(7)/2.)-TAN(ANG1C)*CAR(8)/2.)-CARB(4)
      CALL GSPOS('CAR1',N,'CARD',X,Y,Z,IRZCAR1B,'ONLY')
*--- CAR1A      
      N=2
      X=-X
      Y=-Y
      CALL GSPOS('CAR1',N,'CARD',X,Y,Z,IRZCAR1A,'ONLY')
*--- CAR2A
      N=1
      X=CARA(4)-CAR(8)/2.*SIN(ANGLCAR2)
      Z=CARA(6)+ZH-CARDB(3)-CAR(8)*COS(ANGLCAR2)/2.
      Y=(CARA(7)/2.-TAN(ANG2C)*CAR(8)/2.)-CARA(5)
      CALL GSPOS('CAR2',N,'CARD',X,Y,Z,IRZCAR2A,'ONLY')
*--- CAR2B      
      N=2
      X=-X
      Y=-Y
      CALL GSPOS('CAR2',N,'CARD',X,Y,Z,IRZCAR2B ,'ONLY')
c---------------------------------------------------------------
*
*     LEGS
*
      NMED=MAL
      CALL GSVOLU('LEGB','BOX ',NMED,LEGB, 3,IVOLU)
*
*     empty volumes to be subtracted from LEGB      
      NMED=MN2
*
      CALL GSVOLU('LEG1','TRAP',NMED,LEG1, 11,IVOLU)            
      X=-LEGB(1)+LEG1(1)
      Y=-LEGB(2)+LEG1(4)
      Z=0.
      CALL GSPOS('LEG1',1,'LEGB',X,Y,Z,RY90,'ONLY')      
      Y=-LEGB(2)+2.*1.95-LEG1(4)
      CALL GSPOS('LEG1',2,'LEGB',X,Y,Z,RY90,'ONLY')       
*      
      CALL GSVOLU('LEG2','BOX ',NMED,LEG2, 3,IVOLU)      
      X=-LEGB(1)+LEG2(1)
      Y=-LEGB(2)+1.95
      Z=0.
      CALL GSPOS('LEG2',1,'LEGB',X,Y,Z,0,'ONLY')
*
      CALL GSVOLU('LEG3','BOX ',NMED,LEG3, 3,IVOLU)      
      X=-LEGB(1)+0.65*2.+LEG3(1)+2./10
      Y=LEGB(2)-LEG3(2)
      Z=LEGB(3)-LEG3(3)
      CALL GSPOS('LEG3',1,'LEGB',X,Y,Z,0,'ONLY')
      Z=-LEGB(3)+LEG3(3)
      CALL GSPOS('LEG3',2,'LEGB',X,Y,Z,0,'ONLY')      
*
      CALL GSVOLU('LEG4','BOX ',NMED,LEG4, 3,IVOLU)      
      X=-LEGB(1)+LEG4(1)
      Y=LEGB(2)-LEG4(2)
      Z=0.
      CALL GSPOS('LEG4',1,'LEGB',X,Y,Z,0,'ONLY')
*      
      CALL GSVOLU('LEG5','BOX ',NMED,LEG5, 3,IVOLU)      
      X=LEGB(1)-LEG5(1)
      Y=LEGB(2)-LEG5(2)
      Z=0.
      CALL GSPOS('LEG5',1,'LEGB',X,Y,Z,0,'ONLY')
*
      CALL GSVOLU('LEG6','BOX ',NMED,LEG6, 3,IVOLU)      
      X=-LEGB(1)+0.65*2.+LEG3(1)
      Y=LEGB(2)-LEG6(2)
      Z=0.
      CALL GSPOS('LEG6',1,'LEGB',X,Y,Z,0,'ONLY')      
*
      CALL GSVOLU('LEG7','BOX ',NMED,LEG7, 3,IVOLU)      
      X=LEGB(1)-1.125-0.375
      Y=-LEGB(2)+LEG7(2)
      Z=11.85-.6-LEG7(3)
      CALL GSPOS('LEG7',1,'LEGB',X,Y,Z,0,'ONLY')      
*
      CALL GSVOLU('LEG8','BOX ',NMED,LEG8, 3,IVOLU)      
      Z=0.
      CALL GSPOS('LEG8',1,'LEGB',X,Y,Z,0,'ONLY')      
*
      CALL GSVOLU('LEG9','BOX ',NMED,LEG9, 3,IVOLU)      
      Z=-(11.85-.6-LEG7(3))
      CALL GSPOS('LEG9',1,'LEGB',X,Y,Z,0,'ONLY')      
*
*     Positioning LEG BOXES in CARD
*
      N=1
      X=-CARDB(1)+LEGB(1)+3.8
      Y=-CARDB(2)+LEGB(2)+0.7
      Z=-0.5
      CALL GSPOS('LEGB',N,'CARD',X,Y,Z,0,'MANY')
      N=2
      X=X
      Y=-Y
      CALL GSPOS('LEGB',N,'CARD',X,Y,Z,RX180,'MANY')
      N=3
      X=-X
      Y=Y
      CALL GSROTM(RZALEX180,90.,180.,90.,
     +     270.,180.,0.)
      CALL GSPOS('LEGB',N,'CARD',X,Y,Z,RZ180,'MANY')
      N=4
      X=X
      Y=-Y
      CALL GSPOS('LEGB',N,'CARD',X,Y,Z,RY180,'MANY')
*
c---------------------------------------------------------------
*
*     CARD TOP PLATE
*
*     TPLT
*
      NMED=MAL
      CALL GSVOLU('TPLT','BOX ',NMED,TPLT, 3,IVOLU)
*
* Empty volumes to be subtracted from TPLT
*
      NMED=MN2
      CALL GSVOLU('TOPC','BOX ',NMED,TOPC, 3,IVOLU)
*
      CALL GSVOLU('TH11','BOX ',NMED,TH11, 3,IVOLU)
      CALL GSVOLU('TH12','BOX ',NMED,TH12, 3,IVOLU)
      CALL GSVOLU('TH21','BOX ',NMED,TH21, 3,IVOLU)      
      CALL GSVOLU('TH22','BOX ',NMED,TH22, 3,IVOLU)                      
*
*     XY plane
      CALL GSVOLU('TOPT','TRAP',NMED,TOPT,11,IVOLU)
*
      CALL GSVOLU('TOHO','TUBE',NMED,TOHO,3,IVOLU)

*
*     Positioning empty volumes...
*
*     Positioning TOPC in TPLT
*
      N=1
      X=0.
      Y=0.
      Z=0.     
      CALL GSPOS('TOPC',N,'TPLT',X,Y,Z,0,'ONLY')      
*
*
*     Positioning H11 in TPLT
*
      N=1
      X=-23.6
      Y=14.4
      Z=0.
      CALL GSPOS('TH11',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=2
      X=-23.6
      Y=-14.4
      CALL GSPOS('TH11',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=3
      X=23.6
      Y=14.4
      CALL GSPOS('TH11',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=4
      X=23.6
      Y=-14.4
      CALL GSPOS('TH11',N,'TPLT',X,Y,Z,0,'ONLY')                
*
*     Positioning H12 in TPLT
*
      N=1
      X=-23.6
      Y=5.5
      Z=0.
      CALL GSPOS('TH12',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=2
      X=-23.6
      Y=-5.5
      CALL GSPOS('TH12',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=3
      X=23.6
      Y=5.5
      CALL GSPOS('TH12',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=4
      X=23.6
      Y=-5.5
      CALL GSPOS('TH12',N,'TPLT',X,Y,Z,0,'ONLY')                
*
*     Positioning H21 in TPLT
*
      N=1
      X=-17.2
      Y=19.4
      Z=0.
      CALL GSPOS('TH21',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=2
      X=-17.2
      Y=-19.4
      CALL GSPOS('TH21',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=3
      X=17.2
      Y=19.4
      CALL GSPOS('TH21',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=4
      X=17.2
      Y=-19.4
      CALL GSPOS('TH21',N,'TPLT',X,Y,Z,0,'ONLY')                
*
*     Positioning H22 in TPLT
*
      N=1
      X=-10.2
      Y=19.4
      Z=0.
      CALL GSPOS('TH22',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=2
      X=-10.2
      Y=-19.4
      CALL GSPOS('TH22',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=3
      X=10.2
      Y=19.4
      CALL GSPOS('TH22',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=4
      X=10.2
      Y=-19.4
      CALL GSPOS('TH22',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=5
      X=0.
      Y=19.4
      CALL GSPOS('TH22',N,'TPLT',X,Y,Z,0,'ONLY')                
      N=6
      X=0.
      Y=-19.4
      CALL GSPOS('TH22',N,'TPLT',X,Y,Z,0,'ONLY')                
*
*     Positioning TOPT in TPLT
*
      N=1
      X=-CARDB(1)+4.5/4.
      Y=-CARDB(2)+4.5/2.
      Z=0.
      CALL GSPOS('TOPT',N,'TPLT',X,Y,Z,0,'ONLY')
      N=2
      X=X
      Y=-Y
      CALL GSPOS('TOPT',N,'TPLT',X,Y,Z,RX180,'ONLY')
      N=3
      X=-X
      Y=Y
      CALL GSPOS('TOPT',N,'TPLT',X,Y,Z,RZ180,'ONLY')
      N=4
      X=X
      Y=-Y
      CALL GSPOS('TOPT',N,'TPLT',X,Y,Z,RY180,'ONLY')
*
*     Positioning TOHO in TPLT
*
      N=1
      X=TPLT(1)-6.2-TOHO(1)
      Y=TPLT(2)-4.1-TOHO(2)
      CALL GSPOS('TOHO',N,'TPLT',X,Y,Z,0,'ONLY')
      N=2
      X=-X
      Y=Y
      CALL GSPOS('TOHO',N,'TPLT',X,Y,Z,0,'ONLY')
      N=3
      X=X
      Y=-Y
      CALL GSPOS('TOHO',N,'TPLT',X,Y,Z,0,'ONLY')
      N=4
      X=-X
      Y=Y
      CALL GSPOS('TOHO',N,'TPLT',X,Y,Z,0,'ONLY')
*
*     Positioning TPLT in CARD volume
* 
      N=1
      X=0.
      Y=0.
      Z=CARDB(3)-TPLT(3)
      CALL GSPOS('TPLT',N,'CARD',X,Y,Z,0,'ONLY')    
C---------------------------------------------------------------      
*
*     MAGNETIC SCREEN
*
      NMED=10
      CALL GSVOLU('MGSC','BOX ',NMED,MGSC, 3,IVOLU)      
* Empty volume to be subtracted from MGSC
      NMED=MN2
      CALL GSVOLU('MGSH','BOX ',NMED,MGSH, 3,IVOLU)      

*
*     Positioning in CARD...
*     
      N=1
      X=0.
      Y=0.
      Z=0.
      CALL GSPOS('MGSH',N,'MGSC',X,Y,Z,0,'ONLY')
      Z=-CARDB(3)+MGSC(3)
      CALL GSPOS('MGSC',N,'CARD',X,Y,Z,0,'ONLY') 
c---------------------------------------------------------------      
      RETURN
      END

*
* $Id: gphit.F,v 3.7 2006/05/11 00:14:40 cafagna Exp $
*
* $Log: gphit.F,v $
* Revision 3.7  2006/05/11 00:14:40  cafagna
* A bug in hits retrival for calorimeter
*
* Revision 3.6  2006/05/02 11:46:13  pam-ba
* TOF geometry and position updated and a new material, the mylar, added
*
* Revision 3.5  2006/04/09 23:28:34  cafagna
* Several new things, among this: ND and CARD
*
* Revision 3.4  2005/12/20 12:21:03  cafagna
* gpnd directory added along with ND files
*
* Revision 3.3  2005/06/21 02:41:50  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2002/12/04 15:12:54  pamela
* CAS and CALO geometry modified
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               19/09/2002  11.17.29  by  Jens Lund
*CMZ :  2.03/00 06/11/2000  01.11.37  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 21/10/99  16.30.25  by  Francesco Cafagna
*CMZ :  1.00/02 15/03/96  16.25.51  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   13/02/96
      SUBROUTINE GPHIT
************************************************************************
*                                                                      *
* HITS definition                                                      *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 13/02/96 18.20.10                         *
*                                                                      *
************************************************************************
#include "gphit.inc"
#include "gpsed.inc"
#include "gpkey.inc"
*
* Tof
*
      IF(PTOF) THEN
         CALL GSDETH ('S1  ',CNSED(ISS1,IDS11Y),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
         CALL GSDETH ('S1  ',CNSED(ISS1,IDS12X),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
*
         CALL GSDETH ('S2  ',CNSED(ISS2,IDS21X),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
         CALL GSDETH ('S2  ',CNSED(ISS2,IDS22Y),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
*
         CALL GSDETH ('S3  ',CNSED(ISS3,IDS31Y),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
         CALL GSDETH ('S3  ',CNSED(ISS3,IDS32X),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
*
         CALL GSDETH ('S4  ',CNSED(ISS4,IDS4),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
      ENDIF
*
* TRD
*
      IF(PTRD) THEN
         CALL GSDETH ('TRD ',CNSED(ISTRD,IDTRSO),NHTRD,CHTRD,NBHTRD,
     +   OHTRD,FHTRD)
      ENDIF
*
* CAT
*
      IF(PCAT) THEN
*JeL:
         CALL GSDETH ('CAT ',CNSED(ISCAT,IDCATL),NHCAT,CHCAT, NBHCAT,
     +   OHCAT,FHCAT)
C         CALL GSDETH ('CAT ',CNSED(ISCAT,IDCATT),NHCAT,CHCAT, NBHCAT,
C     +   OHCAT,FHCAT)
*END: JeL.
      ENDIF
*
* CAS
*
      IF(PCAS) THEN
*JeL:
         CALL GSDETH ('CAS ',CNSED(ISCAS,IDCASX),NHCAS,CHCAS,NBHCAS,
     +   OHCAS,FHCAS)
C         CALL GSDETH ('CAS ',CNSED(ISCAS,IDCASY),NHCAS,CHCAS,NBHCAS,
C     +   OHCAS,FHCAS)
*END: JeL.
      ENDIF
*
* SPE
*
      IF(PSPE) CALL GSDETH ('SPE ',CNSED(ISSPE,IDTSPA),
     +             NHSPE,CHSPE,NBHSPE,OHSPE,FHSPE)
*
* CAL
*
      IF(PCAL) THEN
         CALL GSDETH ('CAL ',CNSED(ISCAL,IDCASI),
     +                NHCALI,CHCALI,NBHCALI,OHCALI,FHCALI)
         CALL GSDETH ('CAL ',CNSED(ISCAL,IDCAST),
     +                NHCAL,CHCAL,NBHCAL,OHCAL,FHCAL)
      ENDIF
*
* ND
*
      IF(PND) CALL GSDETH ('ND  ',CNSED(ISND,IDNDTI),
     +             NHND,CHND,NBHND,OHND,FHND)
*
* CARD
*
      IF(PCARD) THEN
         CALL GSDETH ('CARD',CNSED(ISCARD,IDCAR1),NHCARD,
     +        CHCARD,NBHCARD,OHCARD,FHCARD)
         CALL GSDETH ('CARD',CNSED(ISCARD,IDCAR2),NHCARD,
     +        CHCARD,NBHCARD,OHCARD,FHCARD)
      ENDIF
*
* User action
*
      CALL GPUHIT
*
      RETURN
      END

*
* $Id: gpuini.F,v 3.2 2005/12/05 12:15:20 pam-ba Exp $
*
* $Log: gpuini.F,v $
* Revision 3.2  2005/12/05 12:15:20  pam-ba
* new spectrometer geometry and internal magnetic field
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  3.00/00 21/01/2002  16.36.33  by  Marialuigia Ambriola
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 30/04/96  18.28.33  by  Francesco Cafagna
*CMZ :  1.00/03 29/04/96  16.35.14  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   29/04/96
      SUBROUTINE GPUINI
************************************************************************
*                                                                      *
* User action in UGINIT                                                *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 29/04/96 16.27.48                         *
*                                                                      *
************************************************************************
#include "gpunit.inc"
C      INTEGER IPART,IMATE,NPOINT
C      REAL STEP
C      IPART = 3
C      IMATE = 22
C      STEP = .4
C      NPOINT = 90
C      CALL GDRPRT (IPART,IMATE,STEP,NPOINT)
*ML 13/03/2001 MI FACCIO STAMPARE I MATERIALI:
C     CALL GPMATE(0)
*END ML.
C
C Close magnetic field map
C
      CLOSE (LUFMAP1)
      CLOSE (LUFMAP2)
      CLOSE (LUFMAP3)
C
C Close SPE HIT RESOLUTION HISTO FILE
C      
      CLOSE (LURSPE)
      RETURN
      END

*
* $Id: gpdat.F,v 3.22 2006/11/30 12:28:39 cafagna Exp $
*
* $Log: gpdat.F,v $
* Revision 3.22  2006/11/30 12:28:39  cafagna
* CARD geometry updated. New S1 "table", legs included, added. Top magnetic screen has been added as well.
*
* Revision 3.21  2006/11/28 10:26:14  pam-ba
* S3 positioning completed
*
* Revision 3.20  2006/11/16 18:45:28  pam-ba
* Simulated an aluminum container for S4
*
* Revision 3.19  2006/11/16 12:01:12  pam-ba
* S4 dimensions corrected.
*
* Revision 3.18  2006/11/10 11:39:33  pam-ba
* S2 and S1 z-positions corrected, He3 and plystyrene mixture added, Top Plate geometry simulated and titanium mixture added.
*
* Revision 3.17  2006/10/13 16:36:58  pam-ba
* Added a new material, the cadmium, for ND
*
* Revision 3.16  2006/10/12 11:11:20  pam-ba
* ND geometry updated.
*
* Revision 3.15  2006/06/30 15:38:15  pam-ba
* S22 and S12 heights positioned in GPAMELA at the nominal heights in PAMELA (see document: Main geometrical parameters of the PAMELA sub-detectors, 20 December 2005)
*
* Revision 3.14  2006/06/06 10:14:38  pam-ba
* gpmyl.inc and gpdmyl.inc included in gpdat.F, polystyrene data card presence test added in gpdat.F and polystyrene number assigned in gpmat.F
*
* Revision 3.13  2006/06/05 13:56:16  pamela
* Gigantic resonance added for gamma enetering in the calorimeter absorber
*
* Revision 3.12  2006/05/18 10:52:31  pam-ba
* TOF geometry completed and a new material, the polystyrene (density 35 g/l), added
*
* Revision 3.11  2006/05/02 12:24:43  bottai
*  clean a global variable for strip simulation
*
* Revision 3.10  2006/05/02 11:46:13  pam-ba
* TOF geometry and position updated and a new material, the mylar, added
*
* Revision 3.9  2006/04/10 11:07:42  cafagna
* GEN data card updated, ZDGEN added
*
* Revision 3.8  2006/04/09 23:28:32  cafagna
* Several new things, among this: ND and CARD
*
* Revision 3.7  2005/12/20 12:21:03  cafagna
* gpnd directory added along with ND files
*
* Revision 3.6  2005/12/14 03:12:39  cafagna
* Neutron detector added. Geometry and GPCALOR package
*
* Revision 3.5  2005/12/05 12:15:20  pam-ba
* new spectrometer geometry and internal magnetic field
*
* Revision 3.4  2005/07/25 11:53:20  cafagna
* Several updates. See history for details
*
* Revision 3.3  2005/06/21 02:41:43  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2002/12/04 15:12:52  pamela
* CAS and CALO geometry modified
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               14/04/2005  13:38     by  Marialuigia Ambriola
*               16/07/2004  16.44.06  by  Alexey Bakaldin
*CMZ :  3.00/00 04/04/2001  15.19.56  by  Marialuigia Ambriola
*CMZ :  2.03/00 06/11/2000  01.58.14  by  Francesco Cafagna
*CMZ :  2.02/00 12/10/2000  18.37.54  by  Francesco Cafagna
*CMZU:  2.01/00 04/04/2000  17.20.52  by  Unknown
*CMZ :  2.00/00 01/03/2000  21.21.39  by  Francesco Cafagna
*CMZ :  1.02/00 31/12/99  17.53.56  by  Francesco Cafagna
*CMZ :  1.01/00 04/05/96  09.50.23  by  Francesco Cafagna
*CMZ :  1.00/03 17/04/96  17.35.58  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  09.27.01  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPDAT
************************************************************************
*                                                                      *
* Data initialization for PAMELA.                                      *
* Geometry parameter and general constant are definited                *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/95 13.21.27                         *
*                                                                      *
************************************************************************
#include "gclist.inc"
#include "gcflag.inc"
#include "gcunit.inc"
*
#include "gprspe.inc"
#include "gpdrspe.inc"
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpmat.inc"
#include "gpkey.inc"
#include "gphit.inc"
#include "gpdigi.inc"
#include "gprzfi.inc"
#include "gpunit.inc"
#include "gpal.inc"
#include "gpg10.inc"
#include "gpn2g.inc"
#include "gpw.inc"
#include "gpfe.inc"
#include "gpkap.inc"
#include "gptrad.inc"
#include "gproa.inc"
#include "gpcp.inc"
#include "gpscint.inc"
#include "gpsica.inc"
#include "gpsitr.inc"
#include "gpxe.inc"
#include "gpaer.inc"
#include "gpgene.inc"
*EM:
#include "gpce.inc"
#include "gpw2.inc"
#include "gpg10c.inc"
*END: EM.
#include "gpmyl.inc"
#include "gppol.inc"
#include "gpcad.inc"
#include "gpch2.inc"
#include "gphe3.inc"
#include "gptav.inc"
*ML:
#include "gpaltr.inc"
#include "gpseed.inc"
*END ML.
#include "gpstripspe.inc"
#include "gpgig.inc"
#include "gppgmec.inc"
#include "gctrak.inc"

      INTEGER ICP
      LOGICAL TEST,GPLOOK
      CHARACTER*4 CJUNK
*
* Data statements
*
#include "gpdgeo.inc"
#include "gpdmat.inc"
#include "gpdhit.inc"
#include "gpddigi.inc"
#include "gpdal.inc"
#include "gpdg10.inc"
#include "gpdn2g.inc"
#include "gpdw.inc"
#include "gpdfe.inc"
#include "gpdkap.inc"
#include "gpdtrad.inc"
#include "gpdroa.inc"
#include "gpdcp.inc"
#include "gpdscin.inc"
#include "gpdsica.inc"
#include "gpdsitr.inc"
#include "gpdxe.inc"
#include "gpdaer.inc"
*EM:
#include "gpdce.inc"
#include "gpdw2.inc"
#include "gpdg10c.inc"
*END: EM.
#include "gpdmyl.inc"
#include "gpdpol.inc"
#include "gpdcad.inc"
#include "gpdch2.inc"
#include "gpdhe3.inc"
#include "gpdtav.inc"
*ML:
C
C Read the attenuation lengths for the TRD from the file
C
      READ(LUTR) ENATT,ATTTRD
      CLOSE (LUTR)
      CALL VZERO(EY,115)
*END ML.
C
C Set quantities from DATA cards
C
C
C Number of plane without tungsten
C
      ICP = -1
      NCANOW = 1
      DO I=1,3
         CALL UHTOC(NCAL(I),4,CJUNK,4)
         ICP = ICFIND('NOW',CJUNK,1,4)
         IF(ICP.EQ.1) NCANOW = ICDECI(CJUNK,4,4)
      ENDDO
C
C CWN booking and filling
C
      IF(HBOOK.EQ.1) THEN
         HBK = .TRUE.
      ELSE
         HBK = .FALSE.
      ENDIF
C
c Look for longer CWN-tplue selection
C
      IF(HLON.EQ.1) THEN
         HLONG = .TRUE.
      ELSE
         HLONG =.FALSE.
      ENDIF
*ML:29/4/04
C
C Look for the input seeds of the random number generator 
C
C # Please note this superseeds the GEANT defaults set by RNDM card
C # or the ones set by GEANT in ginit.F
C # HFSF = 1, then just read the seeds used to initialize a previous run, 
C #           i.e. repeat the random chain
      IF(HSEED.EQ.1) THEN
         READ(LUFSF) INSEED
         NRNDM(1)=INSEED(1)
         NRNDM(2)=INSEED(2)
         CALL GRNDMQ(NRNDM(1),NRNDM(2),1,'S')
C # HFSF = 2, then just read the last seeds used in a previous run, 
C #           i.e. continue the random chain
      ELSEIF(HSEED.EQ.2) THEN
         READ(LUFSF) INSEED
         NRNDM(1)=INSEED(3)
         NRNDM(2)=INSEED(4)
         CALL GRNDMQ(NRNDM(1),NRNDM(2),1,'S')
      ELSE
C # HFSF not set, use the default GEANT setting
         CALL GRNDMQ(NRNDM(1),NRNDM(2),0,'G')
      ENDIF
      OUTSEED(1)=NRNDM(1)
      OUTSEED(2)=NRNDM(2)
*END ML.

C
C Volume to be subtracted via NDET card
C
      SPH=.NOT.GPLOOK('SPHE',NDET,10)
C
      TOF=.NOT.GPLOOK('TOF ',NDET,10)
      HTOF = .FALSE.
      IF(HBK.AND.TOF) HTOF = .TRUE.
C
      TRD=.NOT.GPLOOK('TRD ',NDET,10)
      HTRD = .FALSE.
      IF(HBK.AND.TRD) HTRD = .TRUE.
C
      CAT =.NOT.GPLOOK('CAT ',NDET,10)
      HCAT = .FALSE.
      IF(HBK.AND.CAT) HCAT = .TRUE.
C
      CAS=.NOT.GPLOOK('CAS ',NDET,10)
      HCAS = .FALSE.
      IF(HBK.AND.CAS) HCAS = .TRUE.
C
      CARD=.NOT.GPLOOK('CARD',NDET,10)
      HCARD = .FALSE.
      IF(HBK.AND.CARD) HCARD = .TRUE.
C
      SPE=.NOT.GPLOOK('SPE ',NDET,10)
      HSPE = .FALSE.
      IF(HBK.AND.SPE) HSPE = .TRUE.
C
      CAL=.NOT.GPLOOK('CAL ',NDET,10)
      HCAL = .FALSE.
      IF(HBK.AND.CAL) HCAL = .TRUE.
C
      ND=.NOT.GPLOOK('ND  ',NDET,10)
      HND = .FALSE.
      IF(HBK.AND.ND) HND = .TRUE.
c$$$
c$$$ TRD AND CARD cannot be activate at the same time. 
c$$$ Precedence to the CARD is given. 
c$$$
      IF(CARD.AND.TRD) THEN 
         TRD = .FALSE.
         HTRD = .FALSE.
      ENDIF
C
C E-ntple or physics disablign for single detectors
C
      IF (CAS) THEN
         CAS=.NOT.GPLOOK('NVOL',NDECAS,3)
         PCAS=.NOT.GPLOOK('NPHY',NDECAS,3)
         HCAS=.NOT.GPLOOK('NHBK',NDECAS,3)
         IF(.NOT.CAS) PCAS = .FALSE.
         IF(.NOT.PCAS)HCAS = .FALSE.
         IF(.NOT.HBK) HCAS = .FALSE.
      ELSE
         PCAS = .FALSE.
         HCAS = .FALSE.
      ENDIF
      IF (CAT) THEN
         CAT=.NOT.GPLOOK('NVOL',NDECAT,3)
         PCAT=.NOT.GPLOOK('NPHY',NDECAT,3)
         HCAT=.NOT.GPLOOK('NHBK',NDECAT,3)
         IF(.NOT.CAT) PCAT = .FALSE.
         IF(.NOT.PCAT)HCAT = .FALSE.
         IF(.NOT.HBK) HCAT = .FALSE.
      ELSE
         PCAT = .FALSE.
         HCAT = .FALSE.
      ENDIF
      IF (CARD) THEN
         CARD=.NOT.GPLOOK('NVOL',NDECARD,3)
         PCARD=.NOT.GPLOOK('NPHY',NDECARD,3)
         HCARD=.NOT.GPLOOK('NHBK',NDECARD,3)
         IF(.NOT.CARD) PCARD = .FALSE.
         IF(.NOT.PCARD)HCARD = .FALSE.
         IF(.NOT.HBK)  HCARD = .FALSE.
      ELSE
         PCARD = .FALSE.
         HCARD = .FALSE.
      ENDIF
      IF (TOF) THEN
         TOF=.NOT.GPLOOK('NVOL',NDETOF,3)
         PTOF=.NOT.GPLOOK('NPHY',NDETOF,3)
         HTOF=.NOT.GPLOOK('NHBK',NDETOF,3)
         IF(.NOT.TOF) PTOF = .FALSE.
         IF(.NOT.PTOF)HTOF = .FALSE.
         IF(.NOT.HBK) HTOF = .FALSE.
      ELSE
         PTOF = .FALSE.
         HTOF = .FALSE.
      ENDIF
      IF (TRD) THEN
         TRD=.NOT.GPLOOK('NVOL',NDETRD,3)
         PTRD=.NOT.GPLOOK('NPHY',NDETRD,3)
         HTRD=.NOT.GPLOOK('NHBK',NDETRD,3)
         IF(.NOT.TRD) PTRD = .FALSE.
         IF(.NOT.PTRD)HTRD = .FALSE.
         IF(.NOT.HBK) HTRD = .FALSE.
      ELSE
         PTRD = .FALSE.
         HTRD = .FALSE.
      ENDIF
      IF (SPE) THEN
         SPE=.NOT.GPLOOK('NVOL',NDESPE,3)
         PSPE=.NOT.GPLOOK('NPHY',NDESPE,3)
         HSPE=.NOT.GPLOOK('NHBK',NDESPE,3)
         IF(.NOT.SPE) PSPE = .FALSE.
         IF(.NOT.PSPE)HSPE = .FALSE.
         IF(.NOT.HBK) HSPE = .FALSE.
      ELSE
         PSPE = .FALSE.
         HSPE = .FALSE.
      ENDIF
      IF (CAL) THEN
         CAL=.NOT.GPLOOK('NVOL',NDECAL,3)
         PCAL=.NOT.GPLOOK('NPHY',NDECAL,3)
         HCAL=.NOT.GPLOOK('NHBK',NDECAL,3)
         IF(.NOT.CAL) PCAL = .FALSE.
         IF(.NOT.PCAL)HCAL = .FALSE.
         IF(.NOT.HBK) HCAL = .FALSE.
      ELSE
         PCAL = .FALSE.
         HCAL = .FALSE.
      ENDIF
      IF (TS4) THEN
         TS4=.NOT.GPLOOK('NVOL',NDES4,3)
         PS4=.NOT.GPLOOK('NPHY',NDES4,3)
         HS4=.NOT.GPLOOK('NHBK',NDES4,3)
         IF(.NOT.TS4)  PS4 = .FALSE.
         IF(.NOT.PS4) HS4 = .FALSE.
         IF(.NOT.HBK) HS4 = .FALSE.
      ELSE
         PS4 = .FALSE.
         HS4 = .FALSE.
      ENDIF
      IF (ND) THEN
         ND=.NOT.GPLOOK('NVOL',NDEND,3)
         PND=.NOT.GPLOOK('NPHY',NDEND,3)
         HND=.NOT.GPLOOK('NHBK',NDEND,3)
         IF(.NOT.ND)  PND = .FALSE.
         IF(.NOT.PND) HND = .FALSE.
         IF(.NOT.HBK) HND = .FALSE.
      ELSE
         PND = .FALSE.
         HND = .FALSE.
      ENDIF
*
* Look for special tracking media settings
*
      TEST =GPLOOK('AL  ',NSPTM,17)
      IF(TEST) CALL GPAL
      TEST =GPLOOK('G10 ',NSPTM,17)
      IF(TEST)  CALL GPG10
*EM:
      TEST =GPLOOK('G10C',NSPTM,17)
      IF(TEST)  CALL GPG10C
*END: EM.
      TEST =GPLOOK('N2G ',NSPTM,17)
      IF(TEST)  CALL GPN2G
      TEST =GPLOOK('W   ',NSPTM,17)
      IF(TEST)  CALL GPW
*EM:
      TEST =GPLOOK('W2  ',NSPTM,17)
      IF(TEST)  CALL GPW2
*END: EM.
      TEST =GPLOOK('FE  ',NSPTM,17)
      IF(TEST)  CALL GPFE
      TEST =GPLOOK('KAP ',NSPTM,17)
      IF(TEST)  CALL GPKAP
      TEST =GPLOOK('TRAD',NSPTM,17)
      IF(TEST)  CALL GPTRAD
      TEST =GPLOOK('ROA ',NSPTM,17)
      IF(TEST)  CALL GPROA
      TEST =GPLOOK('CP  ',NSPTM,17)
      IF(TEST)  CALL GPCP
      TEST =GPLOOK('SCIN',NSPTM,17)
      IF(TEST)  CALL GPSCINT
      TEST =GPLOOK('SICA',NSPTM,17)
      IF(TEST)  CALL GPSICA
      TEST =GPLOOK('SITR',NSPTM,17)
      IF(TEST)  CALL GPSITR
      TEST =GPLOOK('XE  ',NSPTM,17)
      IF(TEST)  CALL GPXE
      TEST =GPLOOK('POL ',NSPTM,17)
      IF(TEST) CALL GPPOL
      TEST =GPLOOK('MYL ',NSPTM,17)
      IF(TEST) CALL GPMYL
      TEST =GPLOOK('CAD ',NSPTM,17)
      IF(TEST) CALL GPCAD
*EM:
      TEST =GPLOOK('CE  ',NSPTM,17)
      IF(TEST)  CALL GPCE
*END EM.
      TEST =GPLOOK('CH2 ',NSPTM,17)
      IF(TEST) CALL GPCH2
      TEST =GPLOOK('HE3 ',NSPTM,17)
      IF(TEST) CALL GPHE3
      TEST =GPLOOK('TAV ',NSPTM,17)
      IF(TEST) CALL GPTAV
*
* Look for parameter to be always atomaticaly calculated by GEANT
*
      ATMAXFD = GPLOOK('TMAX',NAUTMED,5)
      ASTEMAX = GPLOOK('STMA',NAUTMED,5)
      ADEEMAX = GPLOOK('DEEM',NAUTMED,5)
      AEPSIL  = GPLOOK('EPSI',NAUTMED,5)
      ASTMIN  = GPLOOK('STMI',NAUTMED,5)
*
* Look for hadronic package to be used
*
      FLUKA =GPLOOK('FLUK',NHPAK,1)
      GPCALOR =GPLOOK('GCAL',NHPAK,1)
*
* Look for Gaussian straggling parameter
* Please note that is updated only if ISSTR is one !
*
      IF(ISSTR.EQ.1) THEN
         IF(SSTR(1).NE.0) D2SICA = SSTR(1)
         IF(SSTR(2).NE.0) D2SITR = SSTR(2)
      ENDIF
*
* Look for calorimeter planes to be excluded
*
      DO I=1,2*NCAPL
         IF(NCPL(I).GT.0) THEN
            IF(NCPL(I).LE.2*NCAPL) THEN
               NOCAPL(NCPL(I))=.TRUE.
            ELSE
               WRITE(CHMAIL,10100) NCPL(I)
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDDO
*
* Look for calorimeter silicon detectors to be excluded
*
      DO I=1,9
         IF(NCSI(I).GT.0) THEN
            IF(NCSI(I).LE.9) THEN
               NOCASI(NCSI(I))=.TRUE.
            ELSE
               WRITE(CHMAIL,10000) NCSI(I)
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDDO
*
* Look for calorimeter absorber planes to be excluded
*
      DO I=1,NCAPL
         IF(NCAB(I).GT.0) THEN
            IF(NCAB(I).LE.22) THEN
               NOCAAB(NCAB(I))=.TRUE.
            ELSE
               WRITE(CHMAIL,10200) NCAB(I)
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDDO
*
* Origin of PAMELA in the MARS GEANT coordinates system
*
      XYZPOR(1) = 0.
      XYZPOR(2) = 0.
      XYZPOR(3) = 0.
C
C TOF dimensions
C
c      S11M(1)=S11Y(1)*NS11Y+2.*(HMYLTOF/2.)
      S11M(1)=S11Y(1)+2.*(HMYLTOF/2.)
      S11M(2)=S11Y(2)
      S11M(3)=S11Y(3)+2.*(HMYLTOF/2.)
      S12M(1)=S12X(1)
c      S12M(2)=S12X(2)*NS12X+2.*(HMYLTOF/2.)
      S12M(2)=S12X(2)+2.*(HMYLTOF/2.)
      S12M(3)=S12X(3)+2.*(HMYLTOF/2.)
      S21M(1)=S21X(1)
c      S21M(2)=S21X(2)*NS21X+2.*(HMYLTOF/2.)
      S21M(2)=S21X(2)+2.*(HMYLTOF/2.)
      S21M(3)=S21X(3)+2.*(HMYLTOF/2.)
c      S22M(1)=S22Y(1)*NS22Y+2.*(HMYLTOF/2.)
      S22M(1)=S22Y(1)+2.*(HMYLTOF/2.)
      S22M(2)=S22Y(2)
      S22M(3)=S22Y(3)+2.*(HMYLTOF/2.)
C      S31M(1)=S31Y(1)*NS31Y+3.*(HMYLTOF/2.)
      S31M(1)=S31Y(1)+3.*(HMYLTOF/2.)
      S31M(2)=S31Y(2)
      S31M(3)=S31Y(3)+3.*(HMYLTOF/2.)
      S32M(1)=S32X(1)
C      S32M(2)=S32X(2)*NS32X+3.*(HMYLTOF/2.)
      S32M(2)=S32X(2)+3.*(HMYLTOF/2.)
      S32M(3)=S32X(3)+3.*(HMYLTOF/2.)
*
c      S1A(1)=S12M(1)
c      S1A(2)=S12M(2)
      S1A(1)=S11M(1)*NS11Y
      S1A(2)=S12M(2)*NS12X
      S1A(3)=2.*(HGLUTOF/2.)+HPVCMIN/2.+S12M(3)+S11M(3)+HPVCMAX/2.
      POL1(1)=S1A(1)
      POL1(2)=S1A(2)
      POL1(3)=HPVCMAX/2.
      POL2(1)=S1A(1)
      POL2(2)=S1A(2)
      POL2(3)=HPVCMIN/2.
      S1(1)=S1A(1)
      S1(2)=S1A(2)
      S1(3)=2.*(HALTOF/2)+S1A(3)
*
c      S2A(1)=S21M(1)
c      S2A(2)=S22M(2)
      S2A(1)=S22M(1)*NS22Y
      S2A(2)=S21M(2)*NS21X
      S2A(3)=2*(HGLUTOF/2)+S22M(3)+S21M(3)+HPVCMIN/2
      POLY(1)=S2A(1)
      POLY(2)=S2A(2)
      POLY(3)=HPVCMIN/2.
      S2(1)=S2A(1)
      S2(2)=S2A(2)
      S2(3)=2*(HALTOF/2)+S2A(3)
*
C      S3(1)=S32M(1)
C      S3(2)=S31M(2)
      S3(1)=S31M(1)*NS31Y
      S3(2)=S32M(2)*NS32X
      S3(3)=HAIRS3/2.+S31M(3)+S32M(3)
*
* Calculate TRD straw box dimentions add some dead space
*
C #       TRBS(1) = (16.+0.5)*TRSO(2)
C #       TRBS(2) = TRSO(3)
C # +SELF,IF=UNIX
C #       TRBS(3) = 0.246+(1+COS(30./180.*ACOS(-1.)))*TRSO(2)
C # +SELF.
C #       TRBS(3) = 0.246+(1+COSD(30.))*TRSO(2)
C # +SELF.
*
* Calculate TRD radiator thickness
*
c      TRRA(3) = (TRBS(3) - (TRSO(2)*( 1 + COS(30./180.*ACOS(-1.))))) +
c     +           TRFR(3)
*
* Calculate TRD virtual box dimensions
*
c ml:17/11/04:
c      TRDB(1) = TRFR(1)
c      TRDB(2) = TRFR(2)
      TRDB(1) = TRR0(1)
      TRDB(2) = TRR0(2)
c end ml.
*      TRDB(3) = 9*TRBS(3) + 9*TRFR(3) + 2* TRAN(3) + TRDT(3)
c ml: 11/11/04:
c      TRDB(3) = 10*TRFR(3) + 11* TRAN(3) + TRDT(3)
c      TRDB(3)=TRR0(3)+9*TRAN(3)+8*TRFR(3)+TRR2(3)
      TRDB(3)=(TRR0(3)-0.05)+9*TRAN(3)+8*TRFR(3)+TRFM(3)+TRFL(3)
c end ml.
*
* Calculate the silicon ladder and spectrometer plane dimensions
*
c ml: 26/11/04:
c      TRSL(1) = TSPA(1) + 2.*TRCP(1)
c      TRSL(3) = TRCP(3)
c      TRPL(1) = TRSL(1)*NTRSL
c ml: 27/12/04:
c      TRPL(1) = TRSL(1)*NTRSL+4*TRCP(1)
c end ml.
c end ml.
*
* Calculate spectrometer box Z dimentions
*
cc 20/04/05:
c      SPEB(3)=5.*MGFR(3)+TRPB(3)
CC end ml.
*
* Calculate the calorimeter planes dimentions, both for actual and dummy planes
*
C fc mod by caf on 20-10-1999
C      CAPL(3) = ((2.*CALB(3)/NCAPL - 2*CAAB(3))/2.)/2.
C end of mod
*EM:
c      CAPL(3) = (2.*CG10(3) + 2*CASI(3) + DCASIZ/2. )/2.
*F.V.&ML:
C      CAPL(3) = (DCASIZ/2. + 2*CASI(3) + 2.*CAKP(3) +
C     + 2.*CAGL(3)+ 2.*C10C(3) + 2*CAKA(3))/2.
C      CAPD(3) = CAPL(3)
* MA
C #       CAPL(3) =  (DCASIZ/2. + 2*CASI(3))/2.
      CAPL(3) =  CASI(3)
* end MA
      CANS(3) = CAKP(3) + CAGL(3)+ C10C(3) + CAKA(3)
      CAPD(3) = CANS(3)
*END F.V.&ML.
C
C We have repectively: N2, Si, Kapton, Glue, G10C, Kaolinite
C
*END EM.
      CASIOFF = (2.*CASI(1) - CALSTWID*NCASTR)/2. - CASI(1)
*
* Calculate the inner shell dimentions and the TOP shell maximum theta angle
* The inner shel is two centimeters from the external and 1 mm thick
*

*AB:
C      SHEI(2) = SHEL(2) - 2.
      SHEI(2)=0.
C      SHEI(1) = SHEI(2) - .1
      SHEI(1)=0.
C      TSPH(1) = TSPH(2) - .25
#if defined(GPAMELA_UNIX)
C      TSPH(4) = ASIN(SHEL(2)/TSPH(2)) * 180./ACOS(-1.)
       TSPH(4) = ASIN(SHEL(5)/TSPH(2)) * 180./ACOS(-1.)
#endif
#if !defined(GPAMELA_UNIX)
C      TSPH(4) = ASIND(SHEL(2)/TSPH(2))
        TSPH(4) = ASIND(SHEL(5)/TSPH(2))
#endif
*END AB.

*
* Quote definition for the main volumes
*
* Note that the quote are in PAMELA System of reference. They are transformed
* in GEANT coordinates system
*
*EM:
C      ZCAS = ZSPEC
*END EM.
*
* The shells heights are the same of the TRD height
*
*AB:
C      SHEL(3) = (ZTRD + TRDB(3) +PAME(3) )/2.
*END: AB.
*
* Add user defined hieght to the external shell
*
*AB:
C      SHEL(3) = SHEL(3) + DZSH
C      SHEI(3) = SHEL(3)
      SHEI(3)=0.
C      ZSHEL = SHEL(3) - PAME(3)
      ZSHEL=ZCAL+CALS(3)+4.+SHEL(1)
C      ZSHEI = SHEI(3) - PAME(3)
      ZSHEI=0.
C      ZTFLA = ZSHEL + SHEL(3) + TFLA(3)
       ZTFLA = ZSHEL + SHEL(1) + TFLA(3)
#if defined(GPAMELA_UNIX)
C      ZTSPH = (2.*SHEI(3)-PAME(3))-TSPH(2)*COS(TSPH(4)/180.*ACOS(-1.))
      ZTSPH=ZSHEL+SHEL(1)-TSPH(2)*COS(TSPH(4)/180.*ACOS(-1.))
#endif
#if !defined(GPAMELA_UNIX)
C      ZTSPH = (2.*SHEI(3)-PAME(3)) - TSPH(2) * COSD(TSPH(4))
    ZTSPH =ZSHEL+SHEL(1)-TSPH(2)*COSD(TSPH(4))
#endif
      ZMSHE=ZSHEL-SHEL(1)-MSHE(3)
      ZBSPH=ZMSHE-MSHE(3)
*END: AB.
C ml: 30/3/06: ZORMG is the offset in z to go from the reference system of
c PAME to the reference system of the tracker (it is the center of the third
c magnetic module). It is obtained so:
c zormg=zcal+cals(3)+zspebp+hormg. zcal (13.05 cm) is the position of the
c center of the calorometer box in PAME, CALS(3) is the half height of the
c calorimeter (10.639 cm), zspebp (2.97 cm) is the distance
c between the bottom of the last alluminum frame of the tracker and the
c bottom of the base plate, HORMG (22.57 cm) is the distance between the
C center of the third magnetic module and the bottom of the tracker
C (22.66 cm is the distance between the center of the third magnetic module
C and the top of the tracker).
      ZORMG=ZCAL+CALS(3)+ZSPEBP+HORMG
c     S11:
c      ZS1=ZPAMS12X+ZORMG+S12X(3)+HMYLTOF+(HPVCMAX-HPVCMIN)/2.
      ZS1=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+2*TPLA(3)+HTABLE+DTABLEAL+
     +    S1(3)
      ZTRD=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+2*TPLA(3)+TRDB(3)
c now S2 is inside TPLA. So we don't need ZS2, the old position of S2 in PAME:
c In each case, the new position od S2 in PAME has to be calculated as:
C      ZS2=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+2*TPCV(3)+S2(3)
C     TPLA (Top Plate):
      ZTPLA=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+TPLA(3)
c     tracker:  
      ZSPEC=ZCAL+CALS(3)+ZSPEBP+SPEB(3)
C     CASA:
      ZCAS=ZSPEC-2.1
C     CATA:
c ml: now CATA is in the volume TPLA. The following calculation of ZCAT is
c not necessary in the code. Right to have the position of CATA in PAME: 
c      ZCAT=ZCAL+CALS(3)+ZSPEBP+2*SPEB(3)+2*TPLA(3)-CATA(2)
C     S3 (DTPS3 is the distance between the bottom of the top plate and the
c     bottom of S32):
      ZS3=ZCAL+CALS(3)+DTPS3+HMYLTOF+2*S32X(3)+2.*HMYLTOF+HAIRS3/2.
c     S4:
      ZS4=ZCAL-CALS(3)-S4AL(3)
c     ND:
      ZND=ZCAL-CALS(3)-2*S4AL(3)-NDBO(3)
*
*  Temporary CARD quote by Caf.
*  
      ZCARD = ZTRD
*
* Origin of the spectrometer in the MARS GEANT coordinates system
*
      XYZSOR(1) = 0.
      XYZSOR(2) = 0.
c ml: 30/03/06:
c      XYZSOR(3) = ZSPEC
      XYZSOR(3) = ZORMG
*
* Calculate generation surface & quote based on the S11 dimentions
*
      IF(XYZGEN(1).NE.-1111) THEN
         XGEN = XYZGEN(1)
      ELSE
c         XGEN = -S11(1)
         XGEN=-S1(1)
      ENDIF
      IF(XYZGEN(2).NE.-1111) THEN
         YGEN = XYZGEN(2)
      ELSE
C         YGEN = -S11(2)
         YGEN=-S1(2)
      ENDIF
      IF(XYZGEN(3).NE.-1111) THEN
         ZGEN = XYZGEN(3)
      ELSE
C         ZGEN = ZS11 + 2.
         ZGEN=ZS1+2.
      ENDIF
      IF(XYZGEN(4).NE.-1111) THEN
         XDGEN = XYZGEN(4)
      ELSE
C         XDGEN = 2.*S11(1)
         XDGEN = 2.*S1(1)
      ENDIF
      IF(XYZGEN(5).NE.-1111) THEN
         YDGEN = XYZGEN(5)
      ELSE
C         YDGEN= 2.*S11(2)
         YDGEN= 2.*S1(2)
      ENDIF
      IF(XYZGEN(6).NE.-1111) THEN
         ZDGEN = XYZGEN(6)
      ELSE
         ZDGEN= 0.
      ENDIF
C
C Set max and min generation angles
C
      THMIN = THGEN(1)
      THMAX = THGEN(2)
      COS2G = (THGEN(3).EQ.1.)      
      PHMIN = PHGEN(1)
      PHMAX = PHGEN(2)
C
C Tracking media parameters. These have been set following M. Boezio
C suggestions, to be optimized for silicon detectors simulation
*ML:
C The EPSILGP variable will be set in GPMED routine.
* The EPSILGP variable is set now and, if it is the case, it is modified
* in GPMED routine.
*ML.
C The FFIELD variable is passed by a DATA CARD
C
      FIELDMGP = 40.
      IF(VTMAXFD.GT.0.) THEN
         TMAXFDGP = VTMAXFD
*ML:
         BTMAXFD = .TRUE.
*END ML.
      ELSE
         TMAXFDGP = 1.
      ENDIF
      IF(VSTEMAX.GT.0.) THEN
         STEMAXGP = VSTEMAX
*ML:
         BSTEMAX = .TRUE.
*END ML.
      ELSE
         STEMAXGP = 0.05
      ENDIF
      IF(VDEEMAX.GT.0.) THEN
         DEEMAXGP = VDEEMAX
*ML:
         BDEEMAX = .TRUE.
*END ML.
      ELSE
         DEEMAXGP = 0.05
      ENDIF
      IF(VSTMIN.GT.0.) THEN
         STMINGP = VSTMIN
*ML:
         BSTMIN = .TRUE.
*END ML.
      ELSE
         STMINGP = 0.0005
      ENDIF
*ML:
      IF(VEPSIL.GT.0.) THEN
         EPSILGP = VEPSIL
         BEPSIL = .TRUE.
      ENDIF
*END ML.
C
C Read magnetic field map
C
      IF (FFIELD.NE.0) THEN
C fc          DO IX=1,41
C fc             DO IY=1,41
C fc                DO IZ=1,31
C fc                   READ(LUFMAP,ERR=10) FX(IX,IY,IZ),FY(IX,IY,IZ),
C fc      +                                FZ(IX,IY,IZ)
C fc                END DO
C fc             END DO
C fc          END DO
C fc    10    PRINT*,'ERROR READING MAP FILE',IX,IY,IZ
C         CALL HCDIR('//FIELD',' ')
C         CALL HRIN(30,9999,0)
C         CALL HPRNT(30)
C         CALL HBNAME(30,' ',0,'$CLEAR')
C         CALL HBNAME(30,'FIELD',F,'$SET')
C         CALL HNOENT(30,IPTOT)
C         IP=0
C         DO IX=1,41
C            DO IY=1,41
C               DO IZ=1,31
C                  IP=IP+1
C                  CALL HGNT(30,IP,IERR)
C                  FX(IX,IY,IZ)=F(1)
C                  FY(IX,IY,IZ)=F(2)
C                  FZ(IX,IY,IZ)=F(3)
C               END DO
C            END DO
C         END DO
C         CALL HREND('FIELD')

C
C fill magnetic field variable needed for interpolation
C
         CALL GPRBI

      ENDIF

C
C READ THE HISTOGRAMS FOR SPE HIT RESOLUTION AND FILL VECTORS
C
      CALL HCDIR('//RESSPE',' ')
      CALL HRIN(0,99999,0)
      DO IK=0,10
         CALL HUNPAK(1000+2*IK,WX(1,IK+1),' ',1)
         CALL HDELET(1000+2*IK)
         CALL HUNPAK(2000+2*IK,WY(1,IK+1),' ',1)
         CALL HDELET(2000+2*IK)
C PREPARE FOR HISTOGRAMS SAMPLING      
         CALL GPRNHPRE(WX(1,IK+1),NDHIRES)
         CALL GPRNHPRE(WY(1,IK+1),NDHIRES)
      ENDDO
      CALL HREND('RESSPE')
C
C prepare the vector for the global strip position to be filled runtime
C
      DO I=1,NPLANES
       DO II=1,NSENSORS
          DO III=1,NSTRIPX
         GLOBSTRIPX(I,II,III)=0.
          ENDDO
          DO III=1,NSTRIPY
          GLOBSTRIPY(I,II,III)=0.
          ENDDO
       ENDDO
      ENDDO 
*
* Set a new mechanism name for Gigantic resonance
*
*      MEC1(IGMEC) = 'GIG '  
*
* Read gigantic resonance cross section
*
      CALL GPGRSIGMA()
*
* Set run and first event number from RUNG GEANT data card
*
      IRUN = IDRUN
      IEVNT = IDEVT
C
C User action
C
      CALL GPUDAT
10000 FORMAT(' GPDDAT: NCPL out of range, NCPL=',I8,'. Not used')
10100 FORMAT(' GPDDAT: NCSI out of range, NCSI=',I8,'. Not used')
10200 FORMAT(' GPDDAT: NCAB out of range, NCAB=',I8,'. Not used')
      RETURN
      END

      PROGRAM WRITESEEDS
C # A simple program to write the initial seeds in a binary file      
      integer lun
      integer ran(4)
      character*256 filename 

      lun=1
      print*, " Please enter the filename :"
      read*,filename
      length=len_trim(filename) 
      lun=1
      print*, " Opening file : ",filename(1:len_trim(filename))
      open(unit=lun,file=filename,
     +     status='unknown',form='unformatted')
      print*, " Please enter four unsigned integer :"
      read*, (ran(i),i=1,4)
      write(lun) ran
      print*," Seeds : ", ran
      print*," Wrote to file : ",filename(1:len_trim(filename))
      close(lun)
      stop
      end

*
* $Id: gpffr.F,v 3.10 2006/11/10 11:39:33 pam-ba Exp $
*
* $Log: gpffr.F,v $
* Revision 3.10  2006/11/10 11:39:33  pam-ba
* S2 and S1 z-positions corrected, He3 and plystyrene mixture added, Top Plate geometry simulated and titanium mixture added.
*
* Revision 3.9  2006/10/13 16:36:58  pam-ba
* Added a new material, the cadmium, for ND
*
* Revision 3.8  2006/09/25 17:54:18  pam-ba
* bug found and fixed in the data card ND
*
* Revision 3.7  2006/05/18 10:52:31  pam-ba
* TOF geometry completed and a new material, the polystyrene (density 35 g/l), added
*
* Revision 3.6  2006/05/02 11:46:13  pam-ba
* TOF geometry and position updated and a new material, the mylar, added
*
* Revision 3.5  2006/04/10 11:07:42  cafagna
* GEN data card updated, ZDGEN added
*
* Revision 3.4  2006/04/09 23:28:33  cafagna
* Several new things, among this: ND and CARD
*
* Revision 3.3  2005/06/21 02:41:45  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2002/12/04 15:12:54  pamela
* CAS and CALO geometry modified
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               14/04/2005  12:32     by  Marialuigia Ambriola
*               03/10/2002  13.09.35  by  Jens Lund
*CMZ :  3.00/00 01/05/2001  16.02.39  by  Marialuigia Ambriola
*CMZ :  2.03/00 06/11/2000  01.54.21  by  Francesco Cafagna
*CMZ :  2.02/00 12/10/2000  16.03.56  by  Francesco Cafagna
*CMZU:  2.01/00 04/04/2000  18.14.49  by  Unknown
*CMZ :  2.00/00 01/03/2000  12.47.24  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  13.28.17  by  Francesco Cafagna
*CMZ :  1.01/00 02/05/96  08.57.38  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  14.56.37  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  09.10.39  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPFFR
************************************************************************
*                                                                      *
*   To define GPAMELA user's data cards
*                                                                      *
* Called by: UGINIT
* Author: Francesco Cafagna, 30/11/95 16.16.02                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
#include "gpdkey.inc"
*
* User action
*
      CALL GPUFFR
*
*  Define MAGN card to turn on or off the magnet
*
      CALL FFKEY('MAGN',FFIELD,1,'I')
*
*  Define NDET card to exclude detectors from the simulation
*
      CALL FFKEY('NDET',NDET,10,'I')
*
*  Define CALO card to select specific option for CALO detector
*
      CALL FFKEY('CALO',NCAL,3,'I')
*
*  Define HBOOK card to enable CWN booking and filling
*
      CALL FFKEY('HCWN',HBOOK,1,'I')
*
*  Define FSFI card to initialize the seed of the random number generators
*
      CALL FFKEY('HFSF',HSEED,1,'I')
*
*  Define SPTM card to enable special tracking media definition for some
*  material
*
      CALL FFKEY('SPTM',NSPTM,17,'I')
*
*  Define HPAK card to slect FLUKA hadronic package
*
      CALL FFKEY('HPAK',NHPAK,1,'I')
*
*  Define AUTM card to slect AUTO tracking media prameter calculation
*
      CALL FFKEY('AUTM',NAUTMED,5,'I')
*
*  Define cards to define the tracking media prameters values
*
      CALL FFKEY('TMAX',VTMAXFD,1,'R')
      CALL FFKEY('STMA',VSTEMAX,1,'R')
*ML:
      CALL FFKEY('DEEM',VDEEMAX,1,'R')
*      CALL FFKEY('DEMA',VDEEMAX,1,'R')
*END ML.
      CALL FFKEY('EPSI',VEPSIL ,1,'R')
      CALL FFKEY('STMI',VSTMIN ,1,'R')
*ML:
*
*  Define cards to define the tracking parameters for each media
*
      CALL FFKEY('TPAL',TPAL,5,'R')
      CALL FFKEY('TG10',TG10,5,'R')
      CALL FFKEY('TPN2',TPN2,5,'R')
      CALL FFKEY('TPW ',TPW,5,'R')
      CALL FFKEY('TPKA',TPKA,5,'R')
      CALL FFKEY('TPFE',TPFE,5,'R')
      CALL FFKEY('TRAD',TRAD,5,'R')
      CALL FFKEY('TPRO',TPRO,5,'R')
      CALL FFKEY('TPCF',TPCF,5,'R')
      CALL FFKEY('TPSC',TPSC,5,'R')
      CALL FFKEY('TSCA',TSCA,5,'R')
      CALL FFKEY('TSTR',TSTR,5,'R')
      CALL FFKEY('TPXE',TPXE,5,'R')
      CALL FFKEY('TPAE',TPAE,5,'R')
*EM:
      CALL FFKEY('TPW2',TPW2,5,'R')
      CALL FFKEY('TPCE',TPCE,5,'R')
      CALL FFKEY('T10C',T10C,5,'R')
*END EM.
*JeL:
      CALL FFKEY('TPPL',TPPL,5,'R')
*END JeL.
      CALL FFKEY('TMYL',TMYL,5,'R')
      CALL FFKEY('TPOL',TPOL,5,'R')
      CALL FFKEY('TCAD',TCAD,5,'R')
      CALL FFKEY('TCH2',TCH2,5,'R')
      CALL FFKEY('THE3',THE3,5,'R')
      CALL FFKEY('TTAV',TTAV,5,'R')
*
*  Define HBFI to define an user HBOOK file name and LUNIT
*
      CALL FFKEY('HBFI',NHBFILE,21,'I')

*
*  Define GAFI to define the GARFIELD file and LUNIT
*
      CALL FFKEY('GAFI',NGARFILE,21,'I')
*
*  Define FSFI to define a file name and LUNIT to initialize
*  the random number generators 
*
      CALL FFKEY('FSFI',NFSFILE,21,'I')
*
*  Define LSFI to define a file name and LUNIT to store the input and 
*  the output seeds of the random number generators of the current run.
*
      CALL FFKEY('LSFI',NLSFILE,21,'I')
*
*  Define SSTR to enable gaussian straggling in silicon
*
      CALL FFKEY('SSTR',ISSTR,3,'M')
*
*  Define GEN to define generation surface and quote
*
      CALL FFKEY('GEN ',XYZGEN,6,'R')
*
*  Define DZSH to define the height adjust for the external shell SHEL
*
      CALL FFKEY('DZSH',DZSH,1,'R')
*
*  Define HLON to select a longer CWN-tupla
*
      CALL FFKEY('HLON',HLON,1,'I')
*
*  ML: Define PHI to define phi generation angle
*
      CALL FFKEY('PHI ',PHGEN,2,'R')
*
*  Define THET to define theta generation angle
*
      CALL FFKEY('THET',THGEN,3,'R')
*  END ML.
*
*  Define NCPL to exclude calorimeter planes from the geometry definition
*
      CALL FFKEY('NCPL',NCPL,44,'I')
*
*  Define NCSI to exclude calorimeter silicon detectors from a plane
*
      CALL FFKEY('NCSI',NCSI,9,'I')
*
*  Define NCAB to exclude calorimeter absorber planes
*
      CALL FFKEY('NCAB',NCAB,22,'I')
*
*  Define DETEcotr cards to exclude detector volume, physics or n-tple
*  from the simulation
*
      CALL FFKEY('CAS ',NDECAS, 3,'I')
      CALL FFKEY('CAT ',NDECAT, 3,'I')
      CALL FFKEY('CARD',NDECARD,3,'I')
      CALL FFKEY('TOF ',NDETOF, 3,'I')
      CALL FFKEY('TRD ',NDETRD, 3,'I')
      CALL FFKEY('SPE ',NDESPE, 3,'I')
      CALL FFKEY('CAL ',NDECAL, 3,'I')
      CALL FFKEY('S4  ',NDES4,  3,'I')
      CALL FFKEY('ND  ',NDEND,  3,'I')
      RETURN
      END

*
* $Id: gpsed.F,v 3.11 2006/05/02 18:00:10 cafagna Exp $
*
* $Log: gpsed.F,v $
* Revision 3.11  2006/05/02 18:00:10  cafagna
* Bugs fixed in TOF set definition, TOF hit back to the original naming scheme
*
* Revision 3.10  2006/05/02 11:44:49  pam-ba
* TOF geometry and position updated and a new material, the mylar, added
*
* Revision 3.9  2006/05/02 11:21:51  pam-ba
* TOF geometry and position updated and a new material, the mylar, added
*
* Revision 3.8  2006/04/09 23:28:35  cafagna
* Several new things, among this: ND and CARD
*
* Revision 3.7  2006/02/05 22:13:33  cafagna
* A bug in the SPEctrometr hit definition fixed
*
* Revision 3.6  2005/12/20 12:21:03  cafagna
* gpnd directory added along with ND files
*
* Revision 3.5  2005/08/25 11:13:03  lundq
* corrected CAS numbering
*
* Revision 3.4  2005/07/25 11:53:20  cafagna
* Several updates. See history for details
*
* Revision 3.3  2005/06/21 02:41:51  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2002/12/04 15:12:54  pamela
* CAS and CALO geometry modified
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               19/09/2002  11.20.48  by  Jens Lund
*CMZ :  3.00/00 06/04/2001  14.50.18  by  Marialuigia Ambriola
*CMZ :  2.03/00 06/11/2000  01.09.51  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 28/02/2000  18.48.57  by  Francesco Cafagna
*CMZ :  1.02/00 04/02/2000  20.31.22  by  Francesco Cafagna
*CMZ :  1.01/00 16/05/96  17.38.13  by  Francesco Cafagna
*CMZ :  1.00/02 28/03/96  23.38.53  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPSED
*********************************************************************
*
* To define sets, detectors and HITS
*
* The USER set numbers are:
*  S1  = 1
*  S2  = 2
*  S3  = 3
*  S4  = 4
*  TRD = 5
*  CAT = 6
*  CAS = 7
*  SPE = 8
*  CAL = 9
*  ND  = 10
*  CARD= 11
*
* The USER detector numbers are, inside the SET structure,:
*  S11Y= 1
*  S12X= 2
*  S21X= 1
*  S22Y= 2
*  S31Y= 1
*  S32X= 2
*  CHAE= 1
*  TRSI= 1
*JeL:
*C  CATL= 1
*C  CATT= 2
*  TOP1= 1
*C  CASX= 1
*C  CASY= 2
*  SID1= 1
*END: JeL.
*  TSPA= 1
*  CASI= 2
*  CAST= 1, in case the division have been requested
*
* The USER detector type are:
*  1, scintillator counter
*  2, aerogel
*  3, TRD
*  4, silicon detector
*
* Called by: UGINIT
* Author: F. Cafagna 13/02/96 13.21.27                               *
*                                                                    *
**********************************************************************
#include "gpgeo.inc"
#include "gpkey.inc"
#include "gpsed.inc"
*
      INTEGER NBITSV(6),NWHI,NWDI
      CHARACTER*4 CVOLU(6)
*
      CALL VZERO(NBITSV,6)
      NWHI = 100
      NWDI = 100
*
c      CVOLU(1) ='PAME'
*
* Tof
*
      IF(PTOF) THEN
         NVTOF = 2
         NBITSV(1) = 4
         NBITSV(2) = 2
         CVOLU(1) ='S11M'
         CVOLU(2) ='S11Y'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('S1  ','S11Y',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +        ISS1,IDS11Y)
         CNSED(ISS1,IDS11Y) = CVOLU(NVTOF)
*
         NBITSV(1) = 3
         CVOLU(1) ='S12M'
         CVOLU(2) ='S12X'
         CALL GSDET('S1  ','S12X',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS1,IDS12X)
         CNSED(ISS1,IDS12X) = CVOLU(NVTOF)
*
         NBITSV(1) = 2
         CVOLU(1) ='S21M'
         CVOLU(2) ='S21X'
         CALL GSDET('S2  ','S21X',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS2,IDS21X)
         CNSED(ISS2,IDS21X) = CVOLU(NVTOF)
*
         NBITSV(1) = 2
         CVOLU(1) ='S22M'
         CVOLU(2) ='S22Y'
         CALL GSDET('S2  ','S22Y',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS2,IDS22Y)
         CNSED(ISS2,IDS22Y) = CVOLU(NVTOF)
*
         NBITSV(1) = 2
         CVOLU(1) ='S31M'
         CVOLU(2) ='S31Y'
         CALL GSDET('S3  ','S31Y',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS3,IDS31Y)
         CNSED(ISS3,IDS31Y) = CVOLU(NVTOF)
*
         NBITSV(1) = 2
         CVOLU(1) ='S32M'
         CVOLU(2) ='S32X'
         CALL GSDET('S3  ','S32X',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS3,IDS32X)
         CNSED(ISS3,IDS32X) = CVOLU(NVTOF)
*
*ML:
*         NVTOF =1
         NVS4=1
*END ML.
         CVOLU(1) ='S4  '
         CVOLU(2) ='    '
*ML:
*         CALL GSDET('S4  ','S4  ',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
*     +   ISS4,IDS4)
         CALL GSDET('S4  ','S4  ',NVS4,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS4,IDS4)
*         CNSED(ISS4,IDS4) = CVOLU(NVTOF)
         CNSED(ISS4,IDS4) = CVOLU(NVS4)
*END ML.
      ELSE
         ISS1  = -1
         IDS11Y = -1
         IDS12X = -1
         ISS2  = -1
         IDS21X = -1
         IDS22Y = -1
         ISS3   = -1
         IDS31Y = -1
         IDS32X = -1
         ISS4   = -1
         IDS4   = -1
      ENDIF
*
* TRD
*
      IF(PTRD) THEN

         NVTRD = 2
c         NBITSV(1) = 1
c         NBITSV(2) = 1
         NBITSV(1) = 6
         NBITSV(2) = 6
c         CVOLU(2) ='TRDB'
         CVOLU(1) ='TRBS'
         CVOLU(2) ='TRSI'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('TRD ','TRSI',NVTRD,CVOLU,NBITSV,3,NWHI,NWDI,
     +        ISTRD,IDTRSI)
         CNSED(ISTRD,IDTRSI) = CVOLU(NVTRD)
*     ML:
 	 NVTRD=3
         NBITSV(3) = 2
         CVOLU(3) = 'TRSO'
 	 CALL GSDET('TRD ','TRSO',NVTRD,CVOLU,NBITSV,3,NWHI,NWDI,
     +        ISTRD,IDTRSO)
         CNSED(ISTRD,IDTRSO) = CVOLU(NVTRD)
****** DON'T MODIFY !!!!!! SEE GPDTRD
         NVTRD = 2
*END ML.
*
      ELSE
         ISTRD = -1
         IDTRSI= -1
*ML:
	 IDTRSO= -1
*END ML.
      ENDIF
*
* CAT
*
      IF(PCAT) THEN
*JeL:
C         NVCAT = 2
         NVCAT = 1
c         NBITSV(1) = 1
         NBITSV(1) = 1
C         NBITSV(2) = 2
C         CVOLU(1) ='CATB'
C         CVOLU(2) ='CATL'
         CVOLU(1) ='TOP1'
         CVOLU(2) ='    '
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
C         CALL GSDET('CAT ','CATL',NVCAT,CVOLU,NBITSV,1,NWHI,NWDI,
C     +   ISCAT,IDCATL)
         CALL GSDET('CAT ','TOP1',NVCAT,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCAT,IDCATL)
         CNSED(ISCAT,IDCATL) = CVOLU(NVCAT)
C         CVOLU(2) ='CATT'
C         CALL GSDET('CAT ','CATT',NVCAT,CVOLU,NBITSV,1,NWHI,NWDI,
C     +   ISCAT,IDCATT)
C         CNSED(ISCAT,IDCATT) = CVOLU(NVCAT)
      ELSE
         ISCAT = -1
C         IDCATT= -1
         IDCATL= -1
*END: JeL.
      ENDIF
*
* CAS
*
      IF(PCAS) THEN
*JoLu 05-08-25
*         NVCAS = 1
         NVCAS = 4
*JeL:
c         NBITSV(1) = 1
         NBITSV(1) = 4
C         CVOLU(1) ='CASX'

*JoLu 05-08-25
*         CVOLU(1) ='SID1'
*         CVOLU(2) ='    '
*         CVOLU(3) ='    '
*         CVOLU(4) ='    '
         CVOLU(1) ='CASA'
         CVOLU(2) ='STRP'
         CVOLU(3) ='PLA1'
         CVOLU(4) ='SID1'
         CVOLU(5) ='    '
         CVOLU(6) ='    '
C         CALL GSDET('CAS ','CASX',NVCAS,CVOLU,NBITSV,1,NWHI,NWDI,
C     +   ISCAS,IDCASX)
         CALL GSDET('CAS ','SID1',NVCAS,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCAS,IDCASX)
         CNSED(ISCAS,IDCASX) = CVOLU(NVCAS)
C         CVOLU(1) ='CASY'
C         CALL GSDET('CAS ','CASY',NVCAS,CVOLU,NBITSV,1,NWHI,NWDI,
C     +   ISCAS,IDCASY)
C         CNSED(ISCAS,IDCASY) = CVOLU(NVCAS)
*END: JeL.
      ELSE
         ISCAS = -1
         IDCASX= -1
      ENDIF
*
* SPE
*
      IF(PSPE) THEN
         NVSPE = 3
         NBITSV(1) = 3
         NBITSV(2) = 3
         NBITSV(3) = 3
         NBITSV(4) = 3
         NBITSV(5) = 2
         CVOLU(1) ='MGFR'
c$$$         CVOLU(2) ='TRPB'
c$$$         CVOLU(3) ='TPAS'
         CVOLU(2) ='TRSL'
         CVOLU(3) ='TSPA'
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('SPE ','TSPA',NVSPE,CVOLU,NBITSV,4,NWHI,NWDI,
     +   ISSPE,IDTSPA)
         CNSED(ISSPE,IDTSPA) = CVOLU(NVSPE)
      ELSE
         ISSPE = -1
         IDTSPA= -1
      ENDIF
*
* CAL
*
      IF(PCAL) THEN
c         NBITSV(1) = 1
c         NBITSV(2) = 1
c         NBITSV(1) = INT(LOG(FLOAT(2*NCAPL))/LOG(2.)) + 1
c         NBITSV(3) = INT(LOG(FLOAT(NCASTR))/LOG(2.))+1
         NBITSV(1) = 8
         NBITSV(2) = 4
         NBITSV(3) = 8
         CVOLU(1) ='CAPL'
         CVOLU(2) ='CASI'
         CVOLU(3) ='CAST'
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         NVCAL = 3
         CALL GSDET('CAL ','CAST',NVCAL,CVOLU,NBITSV,4, NWHI,NWDI,
     +      ISCAL,IDCAST)
         CNSED(ISCAL,IDCAST) = CVOLU(NVCAL)
*
* CAL second detector to store the energy released per strip
*
         NBITSV(1) = 8
         NBITSV(2) = 8
         CVOLU(1) ='CAPL'
         CVOLU(2) ='CASI'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         NVCALI = 2
         CALL GSDET('CAL ','CASI',NVCALI,CVOLU,NBITSV,4, NWHI,NWDI,
     +      ISCAL,IDCASI)
         CNSED(ISCAL,IDCASI) = CVOLU(NVCALI)
      ELSE
         ISCAL  = -1
         IDCASI = -1
         IDCAST = -1
      ENDIF
*
* ND
*
      IF(PND) THEN
         NVND = 2
         NBITSV(1) = 6
         NBITSV(2) = 6
         CVOLU(1) ='NDTU'
         CVOLU(2) ='NDTI'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('ND  ','NDTI',NVND,CVOLU,NBITSV,3,NWHI,NWDI,
     +        ISND,IDNDTI)
         CNSED(ISND,IDNDTI) = CVOLU(NVND)
      ELSE
         ISND = -1
         IDNDTI= -1
      ENDIF
*
* CARD
*
      IF(PCARD) THEN
         NVCARD = 2
         NBITSV(1) = 3
         CVOLU(1) ='CAR1'
         CVOLU(2) ='C1D1'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('CARD','C1D1',NVCARD,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCARD,IDCAR1)
         CNSED(ISCARD,IDCAR1) = CVOLU(NVCARD)
         CVOLU(1) ='CAR2'
         CVOLU(2) ='C2D1'
         CALL GSDET('CARD','C2D1',NVCARD,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCARD,IDCAR2)
         CNSED(ISCARD,IDCAR2) = CVOLU(NVCARD)
      ELSE
         ISCARD = -1
         IDCAR1 = -1
         IDCAR2 = -1
      ENDIF
*
* User action
*
      CALL GPUSED
      CALL GPSETS('*','*')
*
      RETURN
      END

*
* $Id: ghesig.F,v 3.1 2006/11/03 11:19:54 bottai Exp $
*
* $Log: ghesig.F,v $
* Revision 3.1  2006/11/03 11:19:54  bottai
*  new antiproton cross sections
*
* Revision 1.1.1.1  1995/10/24 10:21:15  cernlib
* Geant
*
*
*CMZ :  3.21/02 29/03/94  15.41.37  by  S.Giani
*-- Author :
      FUNCTION GHESIG(PPART,EKIN,AVER,A,Z,W,KK,DENS,QCOR,LPART)
C
C *** CALCULATION OF THE PROBABILITIES FOR (IN)ELASTIC INTERACTIONS ***
C *** OF STABLE PARTICLES ON PROTON AND NEUTRON                     ***
C *** NVE 07-APR-1988 ***
C
C CALLED BY : GPGHEI
C ORIGIN : F.CARMINATI, H.FESEFELDT (ROUTINE INTACT 06-OCT-1987)
C
C OCTOBER 2006 - MODIFIED BY S.Bottai TO CHANGE ANTIPROTON CROSS SECTIONS 
C
C *** IPART DENOTES THE GHEISHA PARTICLE INDEX ***
C
C CONVENTION :
C
C   PARTICLE                 IPART
C   ------------------------------
C   GAMMA                    1
C   NEUTRINO                 2
C   POSITRON                 3
C   ELECTRON                 4
C   MUON +                   5
C   MUON -                   6
C   PION +                   7
C   PION 0                   8
C   PION -                   9
C   KAON +                  10
C   KAON 0 S                11
C   KAON 0 L                12
C   KAON -                  13
C   PROTON                  14
C   PROTON BAR              15
C   NEUTRON                 16
C   NEUTRON BAR             17
C   LAMBDA                  18
C   LAMBDA BAR              19
C   SIGMA +                 20
C   SIGMA 0                 21
C   SIGMA -                 22
C   SIGMA + BAR             23
C   SIGMA 0 BAR             24
C   SIGMA - BAR             25
C   XSI 0                   26
C   XSI -                   27
C   XSI 0 BAR               28
C   XSI - BAR               29
C   DEUTERON                30
C   TRITON                  31
C   ALPHA                   32
C   OMEGA -                 33
C   OMEGA - BAR             34
C   NEW PARTICLES           35
C
#include "gcunit.inc"
#include "gconsp.inc"
C
C --- FOR CROSS-SECTION INFORMATION SEE "PCSDATA" ---
C
#include "gsecti.inc"
C --- GHEISHA COMMONS ---
#include "s_result.inc"
#include "s_prntfl.inc"
C
      DIMENSION A(KK),Z(KK),W(KK)
C
      DIMENSION ALPHA(35),ALPHAC(41),IPART2(7),CSA(4)
      DIMENSION PARTEL(35),PARTIN(35),ICORR(35),INTRC(35)
C
      PARAMETER (ONETHR=1./3.)
      SAVE ALPHA,ALPHAC,PARTEL,PARTIN,CSA,IPART2,ICORR,INTRC
C
#include "s_csdim.inc"
#include "pcodim.inc"
#include "s_csdat.inc"
#include "pcodat.inc"
C
      DATA ALPHA    / 6*0.7,
     +                0.75 ,0.75 ,0.75 ,
     +                0.76,0.76 ,0.76 ,0.76 ,
     +                0.685,0.63 ,0.685,0.63,0.685,0.63,
     +                3*0.685,3*0.63,2*0.685,2*0.63,
     +                3*0.7,0.685,0.63,0.7/
      DATA ALPHAC    /1.2,1.2,1.2,1.15,0.90,0.91,0.98,1.06,1.10,1.11,
     +                1.10,1.08,1.05,1.01,0.985,0.962,0.945,0.932,
     +                0.925,0.920,0.920,0.921,0.922,0.923,0.928,0.931,
     +                0.940,0.945,0.950,0.955,0.958,0.962,0.965,0.976,
     +                0.982,0.988,0.992,1.010,1.020,1.030,1.040/
      DATA PARTEL/6*0.,29*1./
      DATA PARTIN/6*0.,1.00,0.00,1.05,1.20,1.35,1.30,1.20,1.00,1.30,
     +            1.00,1.30,1.00,1.30,1.00,1.00,1.00,1.30,1.30,1.30,
     +            1.00,1.00,1.30,1.30,1.00,1.,1.,1.,1.3,1./
      DATA ICORR /14*1, 0, 1, 0, 1, 0, 3*1, 3*0, 2*1, 2*0, 4*1, 2*0/
      DATA INTRC /6*0, 1, 0, 12*1, 0, 2*2, 0, 10*1, 0/
C
C CROSS SECTIONS ON NUCLEUS ARE KNOWN ONLY FOR PIONS AND PROTONS.
C THE GENERAL LAW SIGMA(A)=1.25*SIGMA(TOT,PROTON)*A**ALPHA IS VALID
C ONLY FOR MOMENTA > 2 GEV.THE PARAMETRIZATION DONE HERE GIVES ONLY
C A BEHAVIOUR AVERAGED OVER MOMENTA AND PARTICLE TYPES.
C FOR A DETECTOR WITH ONLY A FEW MATERIALS IT'S OF COURSE MUCHBETTER
C TO USE TABLES OF THE MEASURED CROSS SECTIONS .
C FOR ELEMENTS WITH THE FOLLOWING ATOMIC NUMBERS MEASURED CROSS
C SECTIONS ARE AVAILABLE (SEE "PCSDATA").
C
C                 H   AL     CU     PB
      DATA  CSA  /1. ,27.00 ,63.54 ,207.19 /
      DATA IPART2/9,8,7,11,10,13,12/
C
C

C --- Initialise GHESIG and switch to GHEISHA particle code ---
      GHESIG=0.0
      IF(LPART.GT.48)GO TO 160
      IPART=KIPART(LPART)

C
C October 2006 - set flag for new antiproton cross section
C
C IF NEWGHEI=1 NEW CROSS SECTIONS FOR ANTIPROTONS ARE USED
C
C
      NEWGHEI=1
C
C --- No interaction for gammas, neutrinos, electrons, positrons, muons,
C --- neutral pions, neutral sigmas and antisigmas and new particles.
      IF(INTRC(IPART).EQ. 0) GO TO 160
      P=PPART
      EK=EKIN
C
C --- Initialise the cross-sections with 0.0 ---
      DO 10  K=1,KK
         AIEL(K)=0.0
         AIIN(K)=0.0
         AIFI(K)=0.0
         AICA(K)=0.0
   10 CONTINUE
C
      IF ((IPART .GE. 30) .AND. (IPART .LE. 32)) THEN
C
C --- Take geometrical cross sections for inelastic scattering ---
C --- of deuterons, tritons and alphas ---
         IF (IPART .EQ. 30) THEN
            APART=2.0**ONETHR
         ELSEIF (IPART .EQ. 31) THEN
            APART=3.0**ONETHR
         ELSEIF (IPART .EQ. 32) THEN
            APART=4.0**ONETHR
         END IF
         DO 20 K=1,KK
            AIIN(K)=49.0*(APART+A(K)**ONETHR)**2
   20    CONTINUE
         IF (NPRT(9)) THEN
            WRITE(CHMAIL,10000)
            CALL GMAIL(0,0)
         END IF
C
      ELSE IF ((IPART .EQ. 16) .AND. (EK .LE. 0.0327)) THEN
C
C --- Use tables for low energy neutrons ---
C --- get energy bin ---
         JE2=17
         DO 30 J=2,17
            IF (EK .LT. ELAB(J)) THEN
               JE2=J
               GO TO 40
            END IF
   30    CONTINUE
C
   40    JE1=JE2-1
         EKX=MAX(EK,1.0E-9)
         DELAB=ELAB(JE2)-ELAB(JE1)
         DO 70 K=1,KK
C
C --- Get A bin ---
            JA2=15
            DO 50 J=2,15
               IF (A(K) .LT. CNLWAT(J)) THEN
                  JA2=J
                  GO TO 60
               END IF
   50       CONTINUE
C
   60       JA1=JA2-1
            DNLWAT=CNLWAT(JA2)-CNLWAT(JA1)
C
C --- Use linear interpolation or extrapolation by Y=RCE*X+RCA*X+B ---
C
C --- Elastic cross section ---
C --- E interpolation or extrapolation at JA1 ---
            DY=CNLWEL(JA1,JE2)-CNLWEL(JA1,JE1)
            RCE=DY/DELAB
C --- A interpolation or extrapolation at JE1 ---
            DY=CNLWEL(JA2,JE1)-CNLWEL(JA1,JE1)
            RCA=DY/DNLWAT
            B=CNLWEL(JA1,JE1)-RCE*ELAB(JE1)-RCA*CNLWAT(JA1)
            AIEL(K)=RCE*EK+RCA*A(K)+B
C
C --- Inelastic cross section ---
C --- E interpolation or extrapolation at JA1 ---
            DY=CNLWIN(JA1,JE2)-CNLWIN(JA1,JE1)
            RCE=DY/DELAB
C --- A interpolation or extrapolation at JE1 ---
            DY=CNLWIN(JA2,JE1)-CNLWIN(JA1,JE1)
            RCA=DY/DNLWAT
            B=CNLWIN(JA1,JE1)-RCE*ELAB(JE1)-RCA*CNLWAT(JA1)
            AIIN(K)=RCE*EK+RCA*A(K)+B
C
            IZNO=Z(K)+0.01
            AICA(K)=11.12*CSCAP(IZNO)/(EKX*1.0E6)**0.577
   70    CONTINUE
         IF (NPRT(9)) THEN
            WRITE(CHMAIL,10100)
            CALL GMAIL(0,0)
         END IF

            
      ELSE
C
C --- Use parametrization of cross section data for all other cases ---
C
         IF (NPRT(9)) THEN
            WRITE(CHMAIL,10200)
            CALL GMAIL(0,0)
         END IF
C
C --- Get momentum bin ---
         J=40
         DO 80 I=2,41
            IF (P .LT. PLAB(I)) THEN
               J=I-1
               GO TO 90
            END IF
   80    CONTINUE
C
C --- Start with  cross sections for scattering on free protons ---
C --- use linear interpolation or extrapolation by Y=RC*X+B     ---
   90    DX=PLAB(J+1)-PLAB(J)
C --- Elastic cross section ---
         DY=CSEL(IPART,J+1)-CSEL(IPART,J)
         RC=DY/DX
         B=CSEL(IPART,J)-RC*PLAB(J)
         AIELIN=RC*P+B
C --- Inelastic cross section ---
         DY=CSIN(IPART,J+1)-CSIN(IPART,J)
         RC=DY/DX
         B=CSIN(IPART,J)-RC*PLAB(J)
         AIININ=RC*P+B
         ALPH=ALPHA(IPART)
         IF(IPART.LT.14) THEN
            DY=ALPHAC(J+1)-ALPHAC(J)
            RC=DY/DX
            B=ALPHAC(J)-RC*PLAB(J)
            CORFAC=RC*P+B
            ALPH=ALPH*CORFAC
C
            IPART3=IPART2(IPART-6)
C
C --- Elastic cross section ---
            DY=CSEL(IPART3,J+1)-CSEL(IPART3,J)
            RC=DY/DX
            B=CSEL(IPART3,J)-RC*PLAB(J)
            XSECEL=RC*P+B
C --- Inelastic cross section ---
            DY=CSIN(IPART3,J+1)-CSIN(IPART3,J)
            RC=DY/DX
            B=CSIN(IPART3,J)-RC*PLAB(J)
            XSECIN=RC*P+B
C
         END IF
C
         DO 100 K=1,KK
            AIEL(K)=AIELIN
            AIIN(K)=AIININ
C
            IF (A(K) .GE. 1.5) THEN

               IF((IPART.EQ.15).AND.(NEWGHEI.EQ.1) ) THEN
C
C October 2006 - new cross section for antiprotons
C      

                 AIEL(K)=ANTIP_AIEL1(A(K),Z(K),P)
                 AIIN(K)=ANTIP_AII1(A(K),Z(K),P)
                 GO TO 100
	       ENDIF


C
C --- A-dependence from parametrization ---
               CREL=1.0
               CRIN=1.0
C --- Get medium bin  1=Hydr.  2=Al  3=Cu  4=Pb ---
               I=3
               IF (A(K) .LT. 50.0) I=2
               IF (A(K) .GT. 100.0) I=4
               IF ((IPART .EQ. 14) .OR. (IPART .EQ. 16)) THEN
C
C --- Protons and neutrons ---
C
C --- Elastic cross section ---
                  DY=CSPNEL(I-1,J+1)-CSPNEL(I-1,J)
                  RC=DY/DX
                  B=CSPNEL(I-1,J)-RC*PLAB(J)
                  XSECEL=RC*P+B
C --- Inelastic cross section ---
                  DY=CSPNIN(I-1,J+1)-CSPNIN(I-1,J)
                  RC=DY/DX
                  B=CSPNIN(I-1,J)-RC*PLAB(J)
                  XSECIN=RC*P+B
                  IF (AIEL(K) .GE. 0.001) CREL=XSECEL/(0.36*AIEL(K)*
     +            CSA(I)**1.17)
                  AITOT=AIEL(K)+AIIN(K)
                  IF (AITOT .GE. 0.001) CRIN=XSECIN/(AITOT*CSA(I)**
     +            ALPH)
C
               ELSEIF (IPART .LT. 15) THEN
C
C --- Calculate correction factors from values on Al,Cu,Pb for all ---
C --- mesons use linear interpolation or extrapolation by Y=RC*X+B ---
C --- Note that data is only available for pions and protons
                  WGCH=0.5
                  IF (A(K) .LT. 20.0) WGCH=0.5+0.5*EXP(-(A(K)-1.0))
                  AIEL(K)=WGCH*AIEL(K)+(1.0-WGCH)*XSECEL
                  AIIN(K)=WGCH*AIIN(K)+(1.0-WGCH)*XSECIN
C
C --- This section not for kaons ---
                  IF (IPART .LT. 10) THEN
C
C --- Elastic cross section ---
                     DY=CSPIEL(I-1,J+1)-CSPIEL(I-1,J)
                     RC=DY/DX
                     B=CSPIEL(I-1,J)-RC*PLAB(J)
                     XSPIEL=RC*P+B
C --- Inelastic cross section ---
                     DY=CSPIIN(I-1,J+1)-CSPIIN(I-1,J)
                     RC=DY/DX
                     B=CSPIIN(I-1,J)-RC*PLAB(J)
                     XSPIIN=RC*P+B
C
                     IF (AIEL(K) .GE. 0.001) CREL=XSPIEL/(0.36* AIEL(K)
     +               *CSA(I)**1.17)
                     AITOT=AIEL(K)+AIIN(K)
                     IF (AITOT .GE. 0.001) CRIN=XSPIIN/(AITOT*CSA(I)
     +               **ALPH)
                  END IF
               END IF
               AIIN(K)=CRIN*(AIIN(K)+AIEL(K))*A(K)**ALPH
cv               AIIN(K)=CRIN*(AIIN(K))*A(K)**ALPH
               AIEL(K)=CREL*0.36*AIEL(K)*A(K)**1.17
               AIEL(K)=AIEL(K)*PARTEL(IPART)
               AIIN(K)=AIIN(K)*PARTIN(IPART)
            END IF
  100    CONTINUE
C
C --- Fission cross sections ---
C --- A-dependence given by  sigma(3 MeV)=-67.0+38.7*Z**(4/3)/A ---
      END IF
      I=21
      DO 110 II=1,21
         IF (EK .LT. EKFISS(II)) THEN
            I=II
            GO TO 120
         END IF
  110 CONTINUE
C
  120 CONTINUE
      DO 130 K=1,KK
C
C --- No fission for materials with A < 230 ---
         IF (A(K) .GE. 230.) THEN
C
C --- Only data for U(233), U(235) and Pu(239) for Ek .le. 0.01 GeV ---
            J=4
            IF (EK .LE. 0.01) THEN
C
C --- Distinguish U(233), U(235), Pu(239) and U(238) and rest by J=1,4
               IF ((Z(K) .EQ. 92.0).AND.(ABS(A(K)-233.0).LT.0.5))THEN
                  J=1
               ELSEIF((Z(K).EQ.92.0).AND.(ABS(A(K)-235.0).LT.0.5))THEN
                  J=2
               ELSEIF((Z(K).EQ.94.0).AND.(ABS(A(K)-239.0).LT.0.5))THEN
                  J=3
               END IF
            END IF
            IF(J.EQ.4) THEN
C
               Z43BA=Z(K)**(4.0*ONETHR)/A(K)
               Z43BA=MAX(-67.0+38.7*Z43BA,0.)
            ELSE
               Z43BA=1.
            ENDIF
C
C --- Energy dependence taken from U(238) ---
C --- approximated as step-function ---
            AIFI(K)=CSFISS(J,I)*Z43BA
         END IF
  130 CONTINUE
C
C --- Corrections for compounds ---
C --- These corrections should only be applied to inorganic scintill. ---
C --- apply the correction only if user selected it within GEANT ---
      IF (QCOR .GT. 0.0.AND.KK.GT.1) THEN
C --- Do not apply corrections for anti-baryons ---
         IF (ICORR(IPART).EQ.1) THEN
C
C --- ACC40 between 0.3 and 0.5 for Pi+ and Pi0, 0.2 for other mesons ---
            ACC40=0.325
C           IF (IPART .GE. 9) ACC40=0.20
C --- ACC40 = 0.15 for baryons ---
            IF (IPART .GE. 14) ACC40=0.15
C --- ACCA=0.08 for all pions, 0.02 for all other particles ---
            ACCA= 0.08
            IF (IPART .GE. 10) ACCA=0.02
C
            ACCB=0.32*(ACC40-ACCA)
            ACC=ACCA-ACCB*LOG(EK)
            IF (ACC .GT. 0.5) ACC=0.5
            IF (ACC .GT. 0.0) THEN
C
               CAVER=AVER**ACC
               CAVER=1.+(CAVER-1.)*QCOR
               DO 140 K=1,KK
                  AIEL(K)=AIEL(K)*CAVER
                  AIIN(K)=AIIN(K)*CAVER
                  AIFI(K)=AIFI(K)*CAVER
                  AICA(K)=AICA(K)*CAVER
  140          CONTINUE
            END IF
         END IF
      END IF
C
C --- Calculate interaction probability ---
C
C --- Correction factor for high (P > 100 GeV/C) energies ---
      CORH=1.0
C --- Assume a LOG(P) dependence of the correction factor with values ---
C P = 100 GeV/C  ==> CORH = 1.
C P =   1 TeV/C  ==> CORH = 1.25
C     DX=LOG(1000.)-LOG(100.)
C     DY=1.25-1.
C     RC=DY/DX
C     B=1.-RC*LOG(100.)
C     CORH=RC*LOG(P)+B

      IF (P .GT. 100.) CORH=0.1085736156*LOG(P)+0.5
      ALAM=0.0
      DO 150 K=1,KK
         AFACT=AVO*1E-3*DENS*W(K)/A(K)
         AIEL(K)=MAX(CORH*AIEL(K)*AFACT,0.)
         AIIN(K)=MAX(CORH*AIIN(K)*AFACT,0.)
         AIFI(K)=MAX(CORH*AIFI(K)*AFACT,0.)
         AICA(K)=MAX(CORH*AICA(K)*AFACT,0.)
C
         ALAM=ALAM+AIEL(K)+AIIN(K)+AIFI(K)+AICA(K)
  150 CONTINUE
C
C --- Pass the interaction probability to GEANT ---
      GHESIG=ALAM
C
      GO TO 999
C
C --- Printout of skipped particles in case of interface debug ---
  160 IF (NPRT(9)) THEN
         WRITE(CHMAIL,10300) IPART
         CALL GMAIL(0,0)
      END IF
10000 FORMAT(' *GHESIG* GEOM X-SECT. FOR INEL. SCAT. OF D,T AND ALPHA')
10100 FORMAT(' *GHESIG* X-SECT. FROM LOW ENERGY NEUTRON TABLES')
10200 FORMAT(' *GHESIG* X-SECT. FROM PARAMETRIZATION OF DATA')
10300 FORMAT('0*GHESIG* GHEISHA PARTICLE ',I3,' SKIPPED')
  999 END


      FUNCTION ANTIP_AIEL1(A,Z,P)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C AUTHOR : Sergio Bottai , October 2006
C
C
C ANTIPROTON ELASTIC CROSS SECTION(mb) 
C
C Bendiscioli and Kharzeev - Nuovo Cimento Vol. 17 N 6
C
C The parametrization for antiproton-Deuterum elastic cross 
C section given in (Bendiscioli and Kharzeev - 
C  Nuovo Cimento Vol. 17 N 6) is extrapolated to other
C nuclei following the A**(2/3) scaling. 
C
C MUST BE IN  millibarn FOR COMPATIBILITY WITH GHESIG
C
C
C CALLED BY : GHESIG
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC      
      REAL A,P,Z 
      
      P1=P
      IF(P1.LT.0.27) P1=0.27
      IF(P1.GT.100.) P1=100.
      
      
      IF(P1.LT.2.) THEN
       SIGT=129.+78./P1
       SIGR=105.+22.5/(P1**1.58)-14.9*LOG10(P1)
       ANTIP_AIEL1=SIGT-SIGR
      ELSE IF(P1.GE.2..AND.P1.LT.5.) THEN
        ANTIP_AIEL1=1.8*(37.5-2.63/(P1**2.58)-12.6*LOG10(P1))
      ELSE IF(P1.GE.5.) THEN
         ANTIP_AIEL1=(112.+125./P1**1.08+1.15*LOG10(P1)**2
     +    -12.6*LOG10(P1))/2.33   
      ENDIF
      FACTO=A**(2./3.)/2.**(2./3.)
      ANTIP_AIEL1=ANTIP_AIEL1*FACTO
          

      END
      
      FUNCTION ANTIP_AII1(A,Z,P)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C AUTHOR : Sergio Bottai , October 2006
C
C
C
C ANTIPROTON INELASTIC CROSS SECTION(mb)
C
C SIG=SIG0*A**ALPHA
C
C WE USE A PARAMETRIZATION OF SIG0(P),ALPHA(P)
C WHICH APPROXIMATE BETTER THAN 10% THE VALUE
C TABULATED IN Bendiscioli and Kharzeev - Nuovo Cimento Vol. 17 N 6
C 
C
C MUST BE IN  millibarn FOR COMPATIBILITY WITH GHESIG
C
C
C CALLED BY : GHESIG
C
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC       

      REAL A,P,Z

      P1=P
      IF(P1.GT.100.) P1=100.

      AL=0.6+0.011*SQRT(P1) 
      IF(P1.LT.0.1) P1=0.1
      SIG0=70.+20.*P1**(-.4)-10.*(LOG10(2.*P1+1.)**(1.3))
      ANTIP_AII1=SIG0*A**AL
      END      
      

*
* $Id: gpfil.F,v 3.5 2005/12/05 12:15:20 pam-ba Exp $
*
* $Log: gpfil.F,v $
* Revision 3.5  2005/12/05 12:15:20  pam-ba
* new spectrometer geometry and internal magnetic field
*
* Revision 3.3  2005/06/21 02:41:46  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2003/12/17 11:32:47  pamela
* CALO SIMULATION COMPLETED: geometry and special tracking parameters updated and simulation checked by a comparison with the Trieste's standalone Monte Carlo simulation
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               14/04/2005  12:59     by Marialuigia Ambriola
*CMZ :  3.00/00 30/03/2001  14.16.15  by  Marialuigia Ambriola
*CMZ :  2.01/00 08/03/2000  18.33.09  by  Unknown
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  17.53.59  by  Francesco Cafagna
*CMZ :  1.01/00 02/05/96  09.43.56  by  Francesco Cafagna
*CMZ :  1.00/02 21/02/96  10.12.34  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPFIL
************************************************************************
*                                                                      *
*            To open FFREAD and HBOOK files
*
* Called by: GPAMELA,GXINT
*                                                                      *
* Author: Francesco Cafagna, 30/11/95 15.53.48                         *
*                                                                      *
************************************************************************
#include "gppntp.inc"
#include "gpunit.inc"
*
#include "gcflag.inc"
#include "gcbank.inc"
*ML: 3/5/03
#include "gpkey.inc"
#include "gpseed.inc"
#include "gcunit.inc"
*END ML
      LOGICAL EXISTS
      INTEGER IJUNK
      CHARACTER*160 FNAM
      CHARACTER*4 SUF
*
* User action
*
      CALL GPUFIL
*
*             Open a HBOOK4 direct access file
*
      CALL HROPEN(LUHBK,'GPAMELA',CHHBK,'N',NBSIZE,ISTAT)
*
*             Open the magnetic field map
*
C fc +SELF,IF=UNIX.
C fc       OPEN(UNIT=LUFMAP,FILE=CHFMAP,FORM='UNFORMATTED',
C fc      +     STATUS='OLD')
C fc +SELF,IF=-UNIX.
C fc       OPEN(UNIT=LUFMAP,FILE=CHFMAP,FORM='UNFORMATTED',SHARED,
C fc      +     STATUS='OLD',READONLY)
C fc +SELF.
*ML:
CML17/04/2003      CALL HROPEN(LUFMAP,'FIELD',CHFMAP,' ',NBSIZE,ISTAT)
C      CALL HROPEN(LUFMAP,'FIELD',CHFMAP,' ',1024,ISTAT)
C*END ML.

      CALL HROPEN(LUFMAP1,'FIELD1',CHFMAP1,' ',1024,ISTAT)
      IF(ISTAT.NE.0) PRINT*,'ERROR WHILE OPENING MAGN. MAP FILE 1'

      CALL HROPEN(LUFMAP2,'FIELD2',CHFMAP2,' ',1024,ISTAT)
      IF(ISTAT.NE.0) PRINT*,'ERROR WHILE OPENING MAGN. MAP FILE 2'

      CALL HROPEN(LUFMAP3,'FIELD3',CHFMAPEX,' ',1024,ISTAT)
      IF(ISTAT.NE.0) PRINT*,'ERROR WHILE OPENING MAGN. MAP FILE EX'
     




C
C open file with spe hit resolution histograms
C      
      CALL HROPEN(LURSPE,'RESSPE',CHRSPE,' ',1024,istat)

*
*ML: (to simulate the TR from TRD)
      OPEN(UNIT=LUTR,FILE=CHTR,FORM='UNFORMATTED',STATUS='UNKNOWN')
*END ML.
*Ml 27/04/04:
      IF(HSEED.EQ.1.OR.HSEED.EQ.2) THEN
         INQUIRE(FILE=CHFSF,EXIST=EXISTS)
         IF(EXISTS) THEN
            OPEN(UNIT=LUFSF,FILE=CHFSF,FORM='UNFORMATTED',STATUS='OLD')
            WRITE(CHMAIL,10000)HSEED
            CALL GMAIL(1,0)
         ELSE 
            WRITE(CHMAIL,10001)
            CALL GMAIL(1,0)
            STOP
         ENDIF
      ENDIF
      IF(DCLSFI) THEN
         FNAM=CHLSF
      ELSE
         SUF='SEED'
         IJUNK=INDEX(CHHBK,'HIS')
         FNAM = CHHBK(1:IJUNK-1)//SUF         
      ENDIF
C     OPEN(UNIT=LULSF,FILE=CHLSF,FORM='UNFORMATTED',STATUS='UNKNOWN')
      OPEN(UNIT=LULSF,FILE=FNAM,FORM='UNFORMATTED',STATUS='UNKNOWN')
*end ml. 27/04/04
10000 FORMAT(' GPFIL: data card HSEED used with value = ',I1,
     + '. Input file of random seed opened. ')
10001 FORMAT('GPFIL WARNING: INPUT FILE OF RANDOM SEED NOT FOUND.',
     +  '                             THE PROGRAM IS EXITING.',
     +  ' PLEASE CHECK THE CARD *FSFI.')
      END

*
* $Id: gpspev.F,v 3.8 2006/05/02 12:02:43 bottai Exp $
*
* $Log: gpspev.F,v $
* Revision 3.8  2006/05/02 12:02:43  bottai
* micrometric adjustment of spe geometry
*
* Revision 3.7  2005/12/16 10:20:23  cafagna
* Bug fixed in the new update
*
* Revision 3.6  2005/12/16 09:13:59  cafagna
* New small valume added to the tracker frame
*
* Revision 3.5  2005/12/13 10:31:29  pam-ba
* added a new volume, TPGI, in the spectrometer
*
* Revision 3.4  2005/12/05 12:15:21  pam-ba
* new spectrometer geometry and internal magnetic field
*
* Revision 3.3  2005/07/25 11:53:21  cafagna
* Several updates. See history for details
*
* Revision 3.2  2005/06/21 02:42:27  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.1.1.1  2002/07/11 16:02:14  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.02/00 07/03/97  14.48.41  by  Francesco Cafagna
*CMZ :  1.00/02 06/02/96  17.34.50  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   09/12/95
      SUBROUTINE GPSPEV
************************************************************************
*                                                                      *
* Volumes definition for the silicon tracking system and magnet        *
* Called by: GPGEM                                                     *
* Author: Francesco Cafagna, 05/12/95 13.39.41                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
*  Define the SPEB     volume
*
      NMED= MN2
      CALL GSVOLU('SPEB','BOX ',NMED,SPEB, 3,IVOLU)
*
*  Define the MGFR     volume
*
      NMED= MAL
      CALL GSVOLU('MGFR','BOX ',NMED,MGFR, 3,IVOLU)
*
*  Define the MGPL     volume
*
      NMED= MMAG
      CALL GSVOLU('MGPL','BOX ',NMED,MGPL, 3,IVOLU)
*
*  Define the MGPI     volume
*
      NMED= MN2
      CALL GSVOLU('MGPI','BOX ',NMED,MGPI, 3,IVOLU)
*
*  Define the TRPB     volume
*
      NMED= MAL
      CALL GSVOLU('TRPB','BOX ',NMED,TRPB, 3,IVOLU)
*****
cC ml 20/04/05:
*
cc*  Define the TRPL     volume
*  Define the TPAS and TPAI volume
*
      NMED= MN2
CC      CALL GSVOLU('TRPL','BOX ',NMED,TRPL, 3,IVOLU)
      CALL GSVOLU('TPAS','BOX ',NMED,TPAS, 3,IVOLU)
      NMED= MAL
      CALL GSVOLU('TPAI','BOX ',NMED,TPAI, 3,IVOLU)
CC end ml.
****************
*
*  Define the TRSL     volume
*
c ml: 26/11/04:
c      NMED= MN2
      NMED=MSIT
      CALL GSVOLU('TRSL','BOX ',NMED,TRSL, 3,IVOLU)
*
* Define the THBP volume
*
      NMED=MG10C
      CALL GSVOLU('THBP','BOX ',NMED,THBP, 3,IVOLU)
C end ml.
*
*  Define the TSPA     volume
*
      NMED= MSIT
      CALL GSVOLU('TSPA','BOX ',NMED,TSPA, 3,IVOLU)
*
*  Define the TRCP     volume
*
      NMED= MCF
      CALL GSVOLU('TRCP','BOX ',NMED,TRCP, 3,IVOLU)
*
*  Define the TBAL     volume
*
      NMED= MAL
      CALL GSVOLU('TBAL','BOX ',NMED,TBAL, 3,IVOLU)
*
*  Define the MGPA     volume
*
      NMED= MAL
      CALL GSVOLU('MGPA','BOX ',NMED,MGPA, 3,IVOLU)
*
*  Define the TPGA     volume
*
      NMED= MN2
      CALL GSVOLU('TPGA','BOX ',NMED,TPGA, 3,IVOLU)
*
*  Define the TPGI     volume
*
      NMED= MN2
      CALL GSVOLU('TPGI','BOX ',NMED,TPGI, 3,IVOLU)
*
*  Define the TPGU     volume
*
      NMED= MN2
      CALL GSVOLU('TPGU','BOX ',NMED,TPGU, 3,IVOLU)
*
*  Define the TPGD     volume
*
      NMED= MN2
      CALL GSVOLU('TPGD','BOX ',NMED,TPGD, 3,IVOLU)

*
* Positioning volume TSPA     into the mother TRSL
*
      GLUEX=XGLUE-0.0005
      GLUEY=XGLUE
      N= 1
      X= 0.
      Y= 0.
      Z= 0.
      CALL GSPOS('TSPA',N,'TRSL',X,Y,Z,0,'ONLY')
C #       N= 2
C # C      Y= Y - 2.*TSPA(2)
C #       Y=-TRSL(2)/2
C #       CALL GSPOS('TSPA',N,'TRSL',X,Y,Z,0,'ONLY')
c ml: 26/11/04:
* Positioning volume TRCP into mother TPAS
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #       Z=-TRPB(3)+0.11+TRCP(3)
C #       Y=-TRPB(2)+1.5-0.225+TRCP(2)
CC end ml.
c      Z=-TRPB(3)+2*TPAI(3)+TRCP(3)
      Z=TRPB(3)-2*TPAI(3)-TRCP(3)
      y=-TPAS(2)+TRCP(2)
C # end CAF mod
      TPASSPACE=TPAS(1)-(3*TRSL(1)+4*TRCP(1)+3*GLUEX)
      DO I=1,4
CC ml 20/04/05:         
CC         X=-TRPL(1)+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #          X=-TRPB(1)+2.29+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
c ml: 19/9/05: introducing the glue between TRCP and the silicon ladders.
c              for now the glue is a space of nitrogen of 0.015 mm 
c         X=-TPAS(1)+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
C Ml. 15/12/05: introducing a space (along x) between the inner part of the
c  aluminum frame and respectively the first and the last carbon fiber barrel.
c It is has been done increasing the dimension of TPAS along x:
C         X=-TPAS(1)+2*(I-1)*XGLUE+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
         X=-TPAS(1)+TPASSPACE+2*(I-1)*GLUEX+(2*I-1)*TRCP(1)+
     +      2*(I-1)*TRSL(1)
CC end ml
         CALL GSPOS('TRCP',I,'TPAS',X,Y,Z,0,'ONLY')
C # end CAF mod
      ENDDO  
cc ml 20/04/05:
* Positioning volume TRSL     into the mother TPAS
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #       Y=-TRPB(2)+1.5+2*THBP(2)+TRSL(2)
C      Y=2.75
CC      Z= 0.
C      Z=-0.005
c      Z=-TRPB(3)+2*TPAI(3)+TRCP(3)
      Z=TRPB(3)-2*TPAI(3)-TRCP(3)
      DO I=1, NTRSL
c ml: 20/9/05 introducing the glue between TRCP and the silicon ladders.
c         X=-TPAS(1)+2*(MOD(I-1,3)+1)*TRCP(1)+
c     +        (2*(MOD(I-1,3)+1)-1)*TRSL(1)
         X=-TPAS(1)+TPASSPACE+2*(MOD(I-1,3)+1)*TRCP(1)+
     +   (2*(MOD(I-1,3)+1)-1)*GLUEX+(2*(MOD(I-1,3)+1)-1)*TRSL(1)
         IF(I.LE.3) THEN
C ml: 22/9/05:
c            Y=TPAS(2)-TRSL(2)
            Y=TPAS(2)-0.1485+0.0005-TRSL(2)
         ELSE
C            Y=TPAS(2)-3*TRSL(2)
            Y=TPAS(2)-0.1485-GLUEY-3*TRSL(2)
         ENDIF
         CALL GSPOS('TRSL',I,'TPAS',X,Y,Z,0,'ONLY')
      ENDDO
C # end CAF mod
**********
cc ml: 20/04/05
* Positioning volume THBP     into the mother TPAS
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #       Y=-TRPB(2)+1.5+THBP(2)
C # cc      Z= 0.
C #       Z=-TRPB(3)+0.11+TRCP(3)
c ml: 22/9/05:
c      Y=-TPAS(2)+THBP(2)
      Y=-TPAS(2)+0.1485+THBP(2)
C      Z=-0.005
c      Z=-TRPB(3)+2*TPAI(3)+TRCP(3)
      Z=TRPB(3)-2*TPAI(3)-TRCP(3)
      DO I=1, NTHBP
CC         X= -TRPL(1) + 2*I*TRCP(1)+(2*I-1)*THBP(1)
C #          X=-TRPB(1)+2.29+2*I*TRCP(1)+(2*I-1)*THBP(1)
c ml: 21/9/05 introducing the glue between the carbon barrel and the silicon
c       ladders 
c         X=-TPAS(1)+2*I*TRCP(1)+(2*I-1)*THBP(1)
         X=-TPAS(1)+TPASSPACE+2*I*TRCP(1)+(2*I-1)*THBP(1)+
     +      (2*(MOD(I-1,3)+1)-1)*GLUEX
         CALL GSPOS('THBP',I,'TPAS',X,Y,Z,0,'ONLY')
      ENDDO
c end ml.
cc ml: 20/04/05
*
* Positioning volume TPAI into the mother TPAS
*
C # Mod By Caf on 19th Jul 2005 all volumes inside the TPAS
      X=0
      Y=-TPAS(2)+TPAI(2)
c      Z=-TPAS(3)+TPAI(3)
      Z=TRPB(3)-TPAI(3)
C #       X=-TRPB(1)+2.29+TPAI(1)
C #       Y=-TRPB(2)+1.5+2.5+TPAI(2)
C #       Z=-TRPB(3)+TPAI(3)
      CALL GSPOS('TPAI',I,'TPAS',X,Y,Z,0,'ONLY')
C # end CAF mod
*
* Positioning volume TPAS into the mother TRPB
*
C # Mod By Caf on 15th Jul 2005
      X=0
      Y=-TRPB(2)+1.5+TPAS(2)
      Z=0
C #       X=-TRPB(1)+2.29+TPAS(1)
C #       Y=-TRPB(2)+1.5+TPAS(2)
C #       Z=-TRPB(3)+0.11+2*TRCP(3)+TPAS(3)
      CALL GSPOS('TPAS',I,'TRPB',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume MGPA     into the mother MGPL
*
      N= 1
      X= 0.
      Y= 0.
      Z= 0.
      CALL GSPOS('MGPA',N,'MGPL',X,Y,Z,0,'ONLY')
*
* Positioning volume TPGD     into the mother MGFR
*
      X=0.
      Z=-MGFR(3)+TPGD(3)
      Y=0.
      CALL GSPOS('TPGD',N,'MGFR',X,Y,Z,0,'ONLY')
*
* Positioning volume TPGI     into the mother MGFR under MGPL 
*
      N=1
      X=0.
      Z=-MGFR(3)+2*TPGD(3)+TPGI(3)
      Y=0.
      CALL GSPOS('TPGI',N,'MGFR',X,Y,Z,0,'ONLY')
*
* Positioning volume MGPI     into the mother MGPL
*
      N= 1
      X= 0.
      Y= 0.
CC ML 10/11/05:  Positioning volume MGPI     into the mother MGPA
      Z= 0.
      CALL GSPOS('MGPI',N,'MGPA',X,Y,Z,0,'ONLY')
C      Z= -MGFR(3)+2*TPGD(3)+MGPI(3)
C      CALL GSPOS('MGPI',N,'MGFR',X,Y,Z,0,'ONLY')
*
* Positioning volume MGPL     into the mother MGFR
*
c ml: 10/11/05
      N=1
c      Z=-MGFR(3)+MGPL(3)
      Z=-MGFR(3)+2*(TPGD(3)+TPGI(3))+MGPL(3)
      CALL GSPOS('MGPL',N,'MGFR',X,Y,Z,0,'ONLY')
*
* Positioning volume TPGI     into the mother MGFR above MGPL
*
      N=2
      X=0.
      Z=-MGFR(3)+2*(TPGD(3)+TPGI(3)+MGPL(3))+TPGI(3)
      Y=0.
      CALL GSPOS('TPGI',N,'MGFR',X,Y,Z,0,'ONLY')
*
* Positioning volume TPGA     into the mother MGFR
*
C ML: 10/11/05
      N=1
      X=0.
      Y=MGFR(2)-2*(MGFR(2)-TRPB(2))-TPGA(2)
C      Z=-MGFR(3)+2*MGPL(3)+TPGA(3)
C      Z=MGFR(3)-2*TPGU(3)-2*TRPB(3)-TPGA(3)
      Z=-MGFR(3)+2*(TPGD(3)+TPGI(3)+MGPL(3)+TPGI(3))+TPGA(3)
C      Y=-0.75
      CALL GSPOS('TPGA',N,'MGFR',X,Y,Z,0,'ONLY')
*
* Positioning volumes TRPB & MGPL into the mother SPEB
*
      N= 1
      X= 0.
C      Y= SPEB(2) - TRPB(2)
      Y= -MGFR(2) + TRPB(2)
C      Z= SPEB(3) - TRPB(3)
c      Z=-MGFR(3)+2*MGPL(3)+2*TPGA(3)+TRPB(3)
C      Z=MGFR(3)-2*TPGU(3)-TRPB(3)
      Z=-MGFR(3)+2*(TPGD(3)+TPGI(3)+MGPL(3)+TPGI(3)+TPGA(3))+TRPB(3)
C      CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,0,'ONLY')
      CALL GSPOS('TRPB',N,'MGFR',X,Y,Z,0,'ONLY')
c      CALL GSPOS('TRPB',N,'MGFR',X,Y,Z,9,'ONLY')
      Z=SPEB(3)
      DO I=1, 5
         X= 0.
         Y= 0.
C         Z= Z - TRPB(3) - MGFR(3)
         Z=Z-MGFR(3)
         N= I
         CALL GSPOS('MGFR',N,'SPEB',X,Y,Z,0,'ONLY')
C         Y= SPEB(2) - TRPB(2)
C         Z= Z - MGFR(3) - TRPB(3)
C         N= (I+1)
C         IF(I.EQ.5) THEN
CC            CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,10,'ONLY')
C            CALL GSPOS('TRPB',N,'MGFR',X,Y,Z,10,'ONLY')
C         ELSE
CC            CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,0,'ONLY')
C            CALL GSPOS('TRPB',N,'MGFR',X,Y,Z,0,'ONLY')
C         ENDIF
         Z=Z-MGFR(3)
      ENDDO
      N=2
      X=0.
      Y=MGFR(2) - TRPB(2)
      Z=Z-TRPB(3)
      ZTRPB=Z
c      CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,4,'ONLY')
      CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,10,'ONLY')
*
* Positioning volume TBAL into the mother SPEB
*
      DO I=1,2
C DTBAL is the distance along x of the volumes TBAL from the end of TRPB
         DTBAL=3.6
         N=I
         IF(I.EQ.1) THEN
            X=TRPB(1)-3.6-TBAL(1)
         ELSE
            X=-(TRPB(1)-3.6-TBAL(1))
         ENDIF
         Y=MGFR(2) - 2*TRPB(2)-TBAL(2)
         Z=ZTRPB
         CALL GSPOS('TBAL',N,'SPEB',X,Y,Z,0,'ONLY')
      ENDDO
*
* Positioning volume TPGU     into the mother MGFR
*
      X=0.
C      Z=MGFR(3)-TPGU(3)
      Z=-MGFR(3)+2*(TPGD(3)+TPGI(3)+MGPL(3)+TPGI(3)+TPGA(3)+TRPB(3))+
     +   TPGU(3)      
      Y=-MGFR(2)+TRPB(2)
      CALL GSPOS('TPGU',N,'MGFR',X,Y,Z,0,'ONLY')
*
      RETURN
      END
